/*     11.20.00  11.30.00 */
set term !!;


/*    */
execute procedure DB_VERSION_CHECK(1120, 0, -1)!!

/* ------------------------------------------------------ */
/*Add_PurchaseCode.sql*/
/* ------------------------------------------------------ */

/*    Agreements  PurchaseCode -    (36 ) 
        TenderCaption */

alter table Agreements
  add PurchaseCode note150 /*    (36 )*/
!!

/*        -    */
ALTER TABLE TenderCaption
  drop PurchaseCode,
  add PurchaseCode note150
!!

commit work !!


/* ------------------------------------------------------ */
/*alter_exception_ex_ten_adjustduplicate.sql*/
/* ------------------------------------------------------ */

--  ''  ''    EX_TEN_ADJUSTDUPLICATE (64)

ALTER EXCEPTION EX_TEN_ADJUSTDUPLICATE '  :     .'
!!

COMMIT WORK
!!

/* ------------------------------------------------------ */
/*Alter_OOS_for_tenderPlan.sql*/
/* ------------------------------------------------------ */

/*    -   */

alter table OOS_CONTRACT
  add PROGINDEX PROGINDEX NOT NULL
!!

alter table OOS_CONTRACT_PRODUCTS
  add PROGINDEX PROGINDEX NOT NULL
!!

alter table OOS_CONTRACTPROCEDURE
  add PROGINDEX PROGINDEX NOT NULL
!!

alter table OOS_CONTRACT_FINANCES
  add PROGINDEX PROGINDEX NOT NULL, /**/
  add ANumber NOTE50, /* .    -*/
  add PacketSection NOTE512, /*      */
  add SubjectName NOTE2000, /* */
  add MaxPrice MONEY32, /*    */
  add PlacingWay_Code VARCHAR(7), /*   - */
  add PlacingWay_Name VARCHAR(500), /*   - */
  add ChangeReason_ID NOTE50, /*   - */
  add ChangeReason_Name VARCHAR(1000) /*   - */
!!

CREATE INDEX OOS_CONTRACT_IDX_PI ON OOS_CONTRACT (PROGINDEX) !!
CREATE INDEX OOS_CONTRACT_FINANCES_IDX_PI ON OOS_CONTRACT_FINANCES (PROGINDEX) !!
CREATE INDEX OOS_CONTRACT_PRODUCTS_IDX_PI ON OOS_CONTRACT_PRODUCTS (PROGINDEX) !!
CREATE INDEX OOS_CONTRACTPROCEDURE_IDX_PI ON OOS_CONTRACTPROCEDURE (PROGINDEX) !!

/*       1818 - */
UPDATE OOS_CONTRACT SET
  PROGINDEX = 1818
!!
UPDATE OOS_CONTRACT_FINANCES SET
  PROGINDEX = 1818
!!
UPDATE OOS_CONTRACT_PRODUCTS SET
  PROGINDEX = 1818
!!
UPDATE OOS_CONTRACTPROCEDURE SET
  PROGINDEX = 1818
!!

commit work !!


/* ------------------------------------------------------ */
/*Add_TypeInf_ClientDFAccountList.sql*/
/* ------------------------------------------------------ */

/*   TypeInf      CLIENTDFACCOUNTLIST      */

alter table CLIENTDFACCOUNTLIST
  add TypeInf INTVALUE not null
!!

ALTER TABLE CLIENTDFACCOUNTLIST DROP CONSTRAINT IDX_CLIENTDFACCOUNTLIST_ACC_REF !!

ALTER TABLE CLIENTDFACCOUNTLIST ADD CONSTRAINT IDX_CDFACCOUNTLIST_TI_AR UNIQUE (TypeInf, ACC_REF) !!

UPDATE CLIENTDFACCOUNTLIST SET
  TypeInf = 1
!!

commit work !!


/* ------------------------------------------------------ */
/*Chage_PurchaseSocialNKO_domen.sql*/
/* ------------------------------------------------------ */

/*    PurchaseSocialNKO  TenderCaption  bool  IntValue */

alter table TenderCaption
  add TempPSNKO IntValue!!

alter trigger TR_TENDERCAPTION_BU_500 inactive!!

update TenderCaption set
  TempPSNKO = PurchaseSocialNKO!!

drop trigger TR_TENDERCAPTION_BI!!

alter table TenderCaption drop PurchaseSocialNKO!!

commit work !!

alter table TenderCaption
  add PurchaseSocialNKO IntValue!!

CREATE OR ALTER Trigger TR_TENDERCAPTION_BI FOR TENDERCAPTION BEFORE INSERT POSITION 0 as
begin
    if (new.id is null) then new.id = gen_id(g_Shared,1);
    if (new.FacialAccCls is null) then new.FacialAccCls = 0;
    /*         ( ) */
    if (new.ProgIndex = 230 and new.Multipurpose is null) then new.Multipurpose = 0;
    if (new.AcceptSumma is null) then new.AcceptSumma = 0;
    if (new.YearAcceptSumma is null) then new.YearAcceptSumma = 0;
    if (new.Allowance is null) then new.Allowance = 0;
    
    /*  .    ,     */
    if ((new.BudgetRef is null) or (new.BudgetRef = 0)) then
      select fa.BudgetRef from FacialAcc_Cls fa
      where fa.Id = new.FacialAccCls
      into new.BudgetRef;
    /*    ,    */
    if ((new.BudgetRef is null) or (new.BudgetRef = 0)) then
    execute procedure GetIntConst(-1,3) returning_values new.BudgetRef;
    
    if (new.Accepted is null) then new.Accepted = 1;
    if (new.SaleType is null) then new.SaleType = 0;
    if (new.TenderOption is null) then new.TenderOption = 0;
    if (new.InnerNumber is Null) then new.InnerNumber = Gen_ID(G_TenderInnerNumber,1);
    if (new.RefinementCause is Null) then new.RefinementCause = 0;
    if (new.Preference is Null) then new.Preference = 0;
    if (new.UnknownAmount is null) then new.UnknownAmount = 0;
    if (new.SupportUndertaker is null) then new.SupportUndertaker = 0;
    if (new.PurchaseSocialNKO is null) then new.PurchaseSocialNKO = 0;
end!!

update TenderCaption set
  PurchaseSocialNKO = TempPSNKO!!

alter table TenderCaption drop TempPSNKO!!

alter trigger TR_TENDERCAPTION_BU_500 active!!

commit work !!



/* ------------------------------------------------------ */
/*Update_TypeInf_PayDocExchange.sql*/
/* ------------------------------------------------------ */

/*     (  = 50)  TypeInf=50*/

/*       1818 - */
UPDATE PAYDOCEXCHANGE SET
  TYPEINF = 50
WHERE
  CODEFORMAT = 50
!!

commit work !!


/* ------------------------------------------------------ */
/*alter_trig_ffc_for_GISGMP.sql*/
/* ------------------------------------------------------ */

/*      =50  TypeInf(0..10)*/

/*      ,   */
ALTER TRIGGER TR_FACIALFINCAPTION_BU_6 BEFORE UPDATE POSITION 6
as
begin
  if (old.ProgIndex in(63,68,70)) then /*   */
  if (exists(select id from paydocexchange where (paydocref=old.id)and(status<>0)and(TypeInf BETWEEN 0 and 10))) then
    if(/*(new.DOCNUMBER<>old.DOCNUMBER) or ((new.DOCNUMBER is NULL)and(not old.DOCNUMBER is NULL)) or ((old.DOCNUMBER is NULL)and(not new.DOCNUMBER is NULL)) or*/
       (new.SOURCEDOCNUM<>old.SOURCEDOCNUM) or ((new.SOURCEDOCNUM is NULL)and(not old.SOURCEDOCNUM is NULL)) or ((old.SOURCEDOCNUM is NULL)and(not new.SOURCEDOCNUM is NULL)) or
       (new.PAYDATE<>old.PAYDATE) or ((new.PAYDATE is NULL)and(not old.PAYDATE is NULL)) or ((old.PAYDATE is NULL)and(not new.PAYDATE is NULL))or
       /*(new.DOCUMENTDATE<>old.DOCUMENTDATE) or ((new.DOCUMENTDATE is NULL)and(not old.DOCUMENTDATE is NULL)) or ((old.DOCUMENTDATE is NULL)and(not new.DOCUMENTDATE is NULL))or*/
       (new.REESTRDATE<>old.REESTRDATE) or ((new.REESTRDATE is NULL)and(not old.REESTRDATE is NULL)) or ((old.REESTRDATE is NULL)and(not new.REESTRDATE is NULL))or
       (((NEW.credit - OLD.credit)>0.001)or((NEW.credit - OLD.credit)<-0.001)) or
       (new.SOURCEACCOUNT<>old.SOURCEACCOUNT) or
       (new.DESTACCOUNT<>old.DESTACCOUNT) or
       (new.PAYTYPECLS<>old.PAYTYPECLS) or
       (new.NOTE<>old.NOTE) or  ((new.NOTE is NULL)and(not old.NOTE is NULL)) or ((old.NOTE is NULL)and(not new.NOTE is NULL))or
       (new.PAYPRIORITY<>old.PAYPRIORITY) or ((new.PAYPRIORITY is NULL)and(not old.PAYPRIORITY is NULL)) or ((old.PAYPRIORITY is NULL)and(not new.PAYPRIORITY is NULL))or
       (new.REESTR_REF<>old.REESTR_REF) or ((new.REESTR_REF is NULL)and(not old.REESTR_REF is NULL)) or ((old.REESTR_REF is NULL)and(not new.REESTR_REF is NULL))or
       (new.NDS<>old.NDS) or ((new.NDS is NULL)and(not old.NDS is NULL)) or ((old.NDS is NULL)and(not new.NDS is NULL))or
       (new.TAXNOTE<>old.TAXNOTE) or ((new.TAXNOTE is NULL)and(not old.TAXNOTE is NULL)) or ((old.TAXNOTE is NULL)and(not new.TAXNOTE is NULL)) )then
      exception ex_CannotChangeSended;
end
!!

/*     ,   */
ALTER TRIGGER TR_FACIALFINCAPTION_BD_6 BEFORE DELETE POSITION 6
AS
begin
  if (exists(select id from paydocexchange where (paydocref=old.id)and(status<>0)and(TypeInf BETWEEN 0 and 10))) then
    exception ex_CannotChangeSended;
  else
    delete from PayDocExchange where paydocref = old.id;  
end
!!

commit work !!


/* ------------------------------------------------------ */
/*alter_UserGeneratorFields_add_DocParam.sql*/
/* ------------------------------------------------------ */

/*  DocParam   UserGeneratorFields */

ALTER TABLE UserGeneratorFields
  add DocParam Note255 /*  */
!!

commit work !!


/* ------------------------------------------------------ */
/*alter_orgs_org_type_02.00.00.sql*/
/* ------------------------------------------------------ */

/*    - " "    02.00.00 */

ALTER trigger tr_organizations_bi
as
    declare variable c numeric(10,0);
    declare variable CheckKind numeric(10,0);
begin
    if (new.id is null) then new.id = gen_id(g_Shared,1);
    if (new.FUID is null) then new.FUID = new.id;
    if (new.GOSNI is null) then new.GOSNI = 0;
    if (new.Name is null) then new.Name = '  ';
    if (new.City is null) then execute procedure GetVarcharConst(-1,7)
        returning_values new.City;
    if (new.COUNTRY is null) then new.COUNTRY = '';
    if (new.CountryCode is null) then new.CountryCode = 643;
    if (new.ORG_CLS is NULL) then new.ORG_CLS=0;
    if (new.SubINN is null) then new.SubINN=0;
    if (new.INN20 is null) then new.INN20='';
    if (new.RCOrg is null) then new.RCOrg = 0;
    if (new.RegionCls is null) then new.RegionCls = 0;
    if (new.OKATO is null) then new.OKATO = 0;
    if (new.KVSR is null) then new.KVSR = 0;
    if (new.OKFS is null) then new.OKFS = 0;
    if (new.OKOPF is null) then new.OKOPF = 0;
    if (new.FederalRegionCode is null) then
      execute procedure GetIntConst(-1, 27)
        returning_values new.FederalRegionCode;
    if (new.FederalRegionCode is null) then
      new.FederalRegionCode = 0;
    if (new.BudgetRef is null) then new.BudgetRef = 0;
    /*    - */
    if (new.org_type is null) then new.org_type = 20000;
    /*       */
    if ((new.generalorg_ref is null) or (new.org_type < 10000) or (new.org_type >= 20000)) then
      new.generalorg_ref = new.id;
    /*    10 ,      */
    if ((new.INN > 9999999999.9) and (new.INN20 <> '') and (new.INN20 is not null)) then
      exception EX_WRONGKPP;

    execute procedure check_unique_organization(new.inn,  new.inn20);

    if (new.CostAuthority is null) then new.CostAuthority=0;
    if (new.IncomeAuthority is null) then new.IncomeAuthority = 0;
    if (new.DebtAuthority is null) then new.DebtAuthority = 0;
    if (new.SVRAuthority is null) then new.SVRAuthority = 0;
    /*        */
    if (new.Org_Type is not null)
    then begin
      if (new.Org_Type between 10100 and 10299) then
        new.CostAuthority=1;
      if (new.Org_Type between 10300 and 10399) then
        new.CostAuthority=2;
      if (new.Org_Type between 10400 and 10499) then
        new.CostAuthority=4;
      if (((new.Org_Type between 10500 and 10599) and (new.CostAuthority<>16)) or
         (((new.Org_Type between 10000 and 10099) or (new.Org_Type between 10600 and 10799))
         and (new.CostAuthority=0))) then
        new.CostAuthority=8;
    end
    if (new.UseCheck_Card is null) then new.UseCheck_Card = 0;
	if (new.RecordOwnerOrgRef is null) then new.RecordOwnerOrgRef = 0;
end
!!
ALTER trigger tr_organizations_bu
as
  declare variable c integer;
  declare variable checkkind numeric(10,0);
  declare variable abtid integer;
begin
  if (new.gosni is null) then new.gosni = 0;
  if (new.city is null) then execute procedure getvarcharconst(-1,7)
     returning_values new.city;
  if (new.country is null) then new.country = '';
  if (new.countrycode is null) then new.countrycode = 643;
  if (new.org_cls is null) then new.org_cls=0;
  if (new.inn20 is null) then new.inn20='';
  if (new.rcorg is null) then new.rcorg = 0;
  if (new.regioncls is null) then new.regioncls = 0;
  if (new.okato is null) then new.okato = 0;
  if (new.kvsr is null) then new.kvsr = 0;
  if (new.okfs is null) then new.okfs = 0;
  if (new.okopf is null) then new.okopf = 0;
  if (new.federalregioncode is null) then
    execute procedure getintconst(-1, 27)
      returning_values new.federalregioncode;
  if (new.federalregioncode is null) then
    new.federalregioncode = 0;
  if (new.budgetref is null) then new.budgetref = 0;
    /*    - */
  if (new.org_type is null) then new.org_type = 20000;
  /*       */
  if ((new.generalorg_ref is null) or (new.org_type < 10000) or (new.org_type >= 20000)) then
    new.generalorg_ref = new.id;


  /*    10 ,      */
  if ((new.inn <> old.inn) or ((old.inn is null) and (new.inn is not null))) then begin
     if ((new.inn > 9999999999.9) and (new.inn20 <> '')) then
       exception ex_wrongkpp;
  end

  if ( ((new.inn <> old.inn) or ((old.inn is null) and (new.inn is not null)))
    or ( (new.inn20 <> old.inn20) or ((old.inn20 is null) and (new.inn20 is not null))) )
  then
    execute procedure check_unique_organization(new.inn,  new.inn20);
 
  if (new.regioncls <> old.regioncls) then
    update dfaccountsbuhtable set
       regioncls = new.regioncls
    where id = any (select id from org_accounts where org_ref = new.id);

  /*      */
  if (old.id = 0) then
     exception ex_cantmodifyunknownorg;

  /*        */
  if ((new.org_type<>old.org_type) or (new.costauthority<>old.costauthority))
  then begin
    c = new.costauthority;
    if (new.org_type between 10100 and 10299) then
      new.costauthority=1;
    if (new.org_type between 10300 and 10399) then
      new.costauthority=2;
    if (new.org_type between 10400 and 10499) then
      new.costauthority=4;
    if (((new.org_type between 10500 and 10599) and (new.costauthority<>16)) or
       (((new.org_type between 10000 and 10099) or (new.org_type between 10600 and 10799))
       and (new.costauthority=0))) then
      new.costauthority=8;
    if ((new.org_type=old.org_type) and (c<>new.costauthority)) then
        exception ex_wrongcostauthority;
  end
   /*   RegionCls  ,  
       */
  if (new.regioncls <> old.regioncls) then
  begin
    update facialacc_cls fac set
      fac.regioncls = new.regioncls
    where
      new.id = fac.org_ref;
  end
  if (new.UseCheck_Card is null) then new.UseCheck_Card = 0;
  if (new.RecordOwnerOrgRef is null) then new.RecordOwnerOrgRef = 0;
end
!!

commit work !!


/* ------------------------------------------------------ */
/*create_trigger_DBUsers_BD_30.sql*/
/* ------------------------------------------------------ */

/*   ""   ""    */

/*   ""   ""    */
create trigger tr_dbusers_ad_30 for dbusers
active after delete position 30
as 
begin
  update DepartmentCls set
    User_Ref = null
  where
    User_Ref = old.Id;
end
!!

commit work !!


/* ------------------------------------------------------ */
/*Update_BudNotify_Note1_from_255_to_4000.sql*/
/* ------------------------------------------------------ */

/*     Note1  255  4000   BudNotify. */

ALTER TABLE BudNotify
  add Note1_Buf note255
!!

update BudNotify
  set Note1_Buf = Note1
!!

ALTER TABLE BudNotify
  drop Note1,
  add Note1 note4000
!!

update BudNotify
  set Note1 = Note1_Buf 
!!

ALTER TABLE BudNotify
  drop Note1_Buf
!!

commit work !!

/* ------------------------------------------------------ */
/*alter_BudStruct_add_AssignmentKind.sql*/
/* ------------------------------------------------------ */

/*  " "    */

ALTER TABLE BudStruct
  add AssignmentKind CLS NOT NULL /*   */
!!

ALTER TABLE BudStructRights
  add AssignmentKind CLS NOT NULL, /*  ,   */
  add AssignmentKindUp Integer    /*  ,   */
!!

commit work !!

alter trigger TR_BUDSTRUCT_BU_500 inactive !!
alter trigger TR_BUDSTRUCTRIGHTS_BU_500 inactive !!

commit work !!

UPDATE BudStruct SET 
  AssignmentKind = 0
!!

UPDATE BudStructRights SET 
  AssignmentKind = 0,
  AssignmentKindUp = 999999
!!

commit work !!

alter trigger TR_BUDSTRUCT_BU_500 active !!
alter trigger TR_BUDSTRUCTRIGHTS_BU_500 active !!

commit work !!

ALTER TABLE BUDSTRUCT ADD CONSTRAINT FK_BUDSTRUCT_ASSIGNMKIND FOREIGN KEY (ASSIGNMENTKIND) REFERENCES ASSIGNMENTKIND(ID)
!!

/*  , ..     .      */
ALTER TABLE BUDSTRUCT DROP CONSTRAINT UNIQUEREC
!!

ALTER trigger tr_budstruct_bi_0
as
begin
  if (new.id is null) then new.id = gen_id(g_Shared,1);
  if (new.BudgetRef is null) then new.BudgetRef = 0;
  if (new.KVSR is null) then new.KVSR = 0;
  if (new.KCSR is null) then new.KCSR = 0;
  if (new.KFSR is null) then new.KFSR = 0;
  if (new.KVR is null) then new.KVR = 0;
  if (new.KESR is null) then new.KESR = 0;
  if (new.SubKESR is null) then new.SubKESR = 0;
  if (new.RegionCls is null) then new.RegionCls = 0;
  if (new.DirectionCls is null) then new.DirectionCls = 0;
  if (new.Fact is null) then new.Fact = 0;
  if (new.FinType is null) then new.FinType = 0;
  if (new.MeansType is null) then new.MeansType = 0;
  if (new.AssignMentKind is null) then new.AssignMentKind = 0;
  if (new.IsLimitSpend is null) then new.IsLimitSpend = 0;
end
!!

ALTER trigger tr_budstruct_bu_0
as
begin
  if (new.BudgetRef is null) then new.BudgetRef = 0;
  if (new.KVSR is null) then new.KVSR = 0;
  if (new.KCSR is null) then new.KCSR = 0;
  if (new.KFSR is null) then new.KFSR = 0;
  if (new.KVR is null) then new.KVR = 0;
  if (new.KESR is null) then new.KESR = 0;
  if (new.SubKESR is null) then new.SubKESR = 0;
  if (new.RegionCls is null) then new.RegionCls = 0;
  if (new.DirectionCls is null) then new.DirectionCls = 0;
  if (new.Fact is null) then new.Fact = 0;
  if (new.FinType is null) then new.FinType = 0;
  if (new.MeansType is null) then new.MeansType = 0;
  if (new.AssignMentKind is null) then new.AssignMentKind = 0;
  if (new.IsLimitSpend is null) then new.IsLimitSpend = 0;
end
!!

ALTER trigger tr_budstructrights_bi_0
as
Begin
     if (NEW.ID is null) then NEW.ID = gen_id(G_SHARED,1);
     if (NEW.RightRef is null) then NEW.RightRef = 4;
     if (NEW.IsGroup is null) then NEW.IsGroup = 0;
     if (new.KVSR is null) then new.KVSR = 0;
     if ((new.KCSR is null) or (new.KCSR = '')) then new.KCSR = '0';
     if (new.KFSR is null) then new.KFSR = 0;
     if ((new.KVR is null) or (new.KVR = '')) then new.KVR = '0';
     if (new.KESR is null) then new.KESR = 0;
     if (new.SubKESR is null) then new.SubKESR = 0;
     if (new.RegionCls is null) then new.RegionCls = 0;
     if ((new.DirectionCls is null) or (new.DirectionCls = '')) then new.DirectionCls = '0';
     if ((new.Fact is null) or (new.Fact = '')) then new.Fact = '0';
     if ((new.FinType is null) or (new.FinType = '')) then new.FinType = '0';
     if (new.MeansType is null) then new.MeansType = 0;
     if (new.TransfertCls is null) then new.TransfertCls = 0;
     if ((new.BudAllocationCls is null) or (new.BudAllocationCls = '')) then new.BudAllocationCls = '0';
     if ((new.PayPromiseCls is null) or (new.PayPromiseCls = '')) then new.PayPromiseCls = '0';
     if ((new.SubsidyCls is null) or (new.SubsidyCls = '')) then new.SubsidyCls = '0';
     if (new.AssignmentKind is null) then new.AssignmentKind = 0;

     if (new.KfsrUP is null) then new.KFSRUp = new.KFSR;
     if (new.KVSRUP is null) then new.KVSRUP = new.KVSR;
     if (new.KCSRUP is null) then new.KCSRUP = new.KCSR;
     if (new.KVRUP is null) then new.KVRUP = new.KVR;
     if (new.KesrUP is null) then new.KesrUP = new.Kesr;
     if (new.SubKESRUP is null) then new.SubKESRUP = new.SubKESR;
     if (new.RegionClsUP is null) then new.RegionClsUP = new.RegionCls;
     if ((new.DirectionClsUp is null) or (new.DirectionClsUp = '')) then new.DirectionClsUp = new.DirectionCls;
     if ((new.FactUP is null) or (new.FactUP='')) then new.FactUP = new.Fact;
     if ((new.FinTypeUP is null) or (new.FinTypeUP='')) then new.FinTypeUP = new.FinType;
     if (new.MeansTypeUP is null) then new.MeansTypeUP = new.MeansType;
     if (new.TransfertClsUp is null) then new.TransfertClsUp = new.TransfertCls;
     if ((new.BudAllocationClsUp is null) or (new.BudAllocationClsUp = '')) then new.BudAllocationClsUp = new.BudAllocationCls;
     if ((new.PayPromiseClsUp is null) or (new.PayPromiseClsUp = '')) then new.PayPromiseClsUp = new.PayPromiseCls;
     if ((new.SubsidyClsUp is null) or (new.SubsidyClsUp = '')) then new.SubsidyClsUp = new.SubsidyCls;
     if (new.AssignmentKindUP is null) then new.AssignmentKindUP = new.AssignmentKind;
End
!!

ALTER trigger tr_budstructrights_bu_0
as
Begin
     if (NEW.RightRef is null) then NEW.RightRef = 4;
     if (NEW.IsGroup is null) then NEW.IsGroup = 0;
     if (new.KVSR is null) then new.KVSR = 0;
     if ((new.KCSR is null) or (new.KCSR = '')) then new.KCSR = '0';
     if (new.KFSR is null) then new.KFSR = 0;
     if ((new.KVR is null) or (new.KVR = '')) then new.KVR = '0';
     if (new.KESR is null) then new.KESR = 0;
     if (new.SubKESR is null) then new.SubKESR = 0;
     if (new.RegionCls is null) then new.RegionCls = 0;
     if ((new.DirectionCls is null) or (new.DirectionCls = '')) then new.DirectionCls = '0';
     if ((new.Fact is null) or (new.Fact = '')) then new.Fact = '0';
     if ((new.FinType is null) or (new.FinType = '')) then new.FinType = '0';
     if (new.MeansType is null) then new.MeansType = 0;
     if (new.TransfertCls is null) then new.TransfertCls = 0;
     if ((new.BudAllocationCls is null) or (new.BudAllocationCls = '')) then new.BudAllocationCls = '0';
     if ((new.PayPromiseCls is null) or (new.PayPromiseCls = '')) then new.PayPromiseCls = '0';
     if ((new.SubsidyCls is null) or (new.SubsidyCls = '')) then new.SubsidyCls = '0';
     if (new.AssignmentKind is null) then new.AssignmentKind = 0;

     if (new.KfsrUP is null) then new.KFSRUp = new.KFSR;
     if (new.KVSRUP is null) then new.KVSRUP = new.KVSR;
     if (new.KCSRUP is null) then new.KCSRUP = new.KCSR;
     if (new.KVRUP is null) then new.KVRUP = new.KVR;
     if (new.KesrUP is null) then new.KesrUP = new.Kesr;
     if (new.SubKESRUP is null) then new.SubKESRUP = new.SubKESR;
     if (new.RegionClsUP is null) then new.RegionClsUP = new.RegionCls;
     if ((new.DirectionClsUp is null) or (new.DirectionClsUp = '')) then new.DirectionClsUp = new.DirectionCls;
     if ((new.FactUP is null) or (new.FactUP='')) then new.FactUP = new.Fact;
     if ((new.FinTypeUP is null) or (new.FinTypeUP='')) then new.FinTypeUP = new.FinType;
     if (new.MeansTypeUP is null) then new.MeansTypeUP = new.MeansType;
     if (new.TransfertClsUp is null) then new.TransfertClsUp = new.TransfertCls;
     if ((new.BudAllocationClsUp is null) or (new.BudAllocationClsUp = '')) then new.BudAllocationClsUp = new.BudAllocationCls;
     if ((new.PayPromiseClsUp is null) or (new.PayPromiseClsUp = '')) then new.PayPromiseClsUp = new.PayPromiseCls;
     if ((new.SubsidyClsUp is null) or (new.SubsidyClsUp = '')) then new.SubsidyClsUp = new.SubsidyCls;
     if (new.AssignmentKindUP is null) then new.AssignmentKindUP = new.AssignmentKind;
End
!!

CREATE EXCEPTION EX_BUDSTRUCT_UNIQUE '  '
!!

commit work !!

/*     */
CREATE trigger tr_budstruct_bi_100 for budstruct
active before insert position 100
AS
begin
  if (exists (select id from BudStruct
      where
        (BUDGETREF = new.BUDGETREF) and
        (KFSR = new.KFSR) and
        (KVSR = new.KVSR) and
        (KCSR = new.KCSR) and
        (KVR = new.KVR) and
        (KESR = new.KESR) and
        (SUBKESR = new.SUBKESR) and
        (REGIONCLS = new.REGIONCLS) and
        (FACT = new.FACT) and
        (FINTYPE = new.FINTYPE) and
        (MEANSTYPE = new.MEANSTYPE) and
        (DIRECTIONCLS = new.DIRECTIONCLS) and
        ((TRANSFERTCLS = new.TRANSFERTCLS) or ((TRANSFERTCLS is null) and (new.TRANSFERTCLS is null))) and
        ((BUDALLOCATIONCLS = new.BUDALLOCATIONCLS) or ((BUDALLOCATIONCLS is null) and (new.BUDALLOCATIONCLS is null))) and
        ((PAYPROMISECLS = new.PAYPROMISECLS) or ((PAYPROMISECLS is null) and (new.PAYPROMISECLS is null))) and
        ((SUBSIDYCLS = new.SUBSIDYCLS) or ((SUBSIDYCLS is null) and (new.SUBSIDYCLS is null))) and
        (ASSIGNMENTKIND = new.ASSIGNMENTKIND)
      ))
  then
    exception EX_BUDSTRUCT_UNIQUE;
end
!!

/*     */
CREATE trigger tr_budstruct_bu_100 for budstruct
active before update position 100
AS
begin
  if (exists (select id from BudStruct
      where
        (BUDGETREF = new.BUDGETREF) and
        (KFSR = new.KFSR) and
        (KVSR = new.KVSR) and
        (KCSR = new.KCSR) and
        (KVR = new.KVR) and
        (KESR = new.KESR) and
        (SUBKESR = new.SUBKESR) and
        (REGIONCLS = new.REGIONCLS) and
        (FACT = new.FACT) and
        (FINTYPE = new.FINTYPE) and
        (MEANSTYPE = new.MEANSTYPE) and
        (DIRECTIONCLS = new.DIRECTIONCLS) and
        ((TRANSFERTCLS = new.TRANSFERTCLS) or ((TRANSFERTCLS is null) and (new.TRANSFERTCLS is null))) and
        ((BUDALLOCATIONCLS = new.BUDALLOCATIONCLS) or ((BUDALLOCATIONCLS is null) and (new.BUDALLOCATIONCLS is null))) and
        ((PAYPROMISECLS = new.PAYPROMISECLS) or ((PAYPROMISECLS is null) and (new.PAYPROMISECLS is null))) and
        ((SUBSIDYCLS = new.SUBSIDYCLS) or ((SUBSIDYCLS is null) and (new.SUBSIDYCLS is null))) and
        (ASSIGNMENTKIND = new.ASSIGNMENTKIND) and
        (id <> old.id)
      ))
  then
    exception EX_BUDSTRUCT_UNIQUE;
end
!!

commit work !!


/* ------------------------------------------------------ */
/*Add_Const_ProgIndex_240_242_243.sql*/
/* ------------------------------------------------------ */



execute procedure AddVarcharConst(1001, 240, '', '      ')
!!
execute procedure AddVarcharConst(1002, 240, '', '      ')
!!

execute procedure AddVarcharConst(1001, 242, '', '     ')
!!
execute procedure AddVarcharConst(1002, 242, '', '     ')
!!

execute procedure AddVarcharConst(1001, 243, '', '      ')
!!
execute procedure AddVarcharConst(1002, 243, '', '      ')
!!

commit work
!!



/* ------------------------------------------------------ */
/*Update_FACIALACC_CLS_FacialCodeEx_from_50_to_4000.sql*/
/* ------------------------------------------------------ */

/*     FacialCodeEx  50  4000   FACIALACC_CLS. */

ALTER TRIGGER TR_FACIALACC_CLS_BU_500 inactive 
!!

ALTER TABLE FACIALACC_CLS
  add FacialCodeEx_Buf note50
!!

update FACIALACC_CLS
  set FacialCodeEx_Buf = FacialCodeEx
!!

ALTER TABLE FACIALACC_CLS
  drop FacialCodeEx,
  add FacialCodeEx note4000
!!

update FACIALACC_CLS
  set FacialCodeEx = FacialCodeEx_Buf 
!!

ALTER TABLE FACIALACC_CLS
  drop FacialCodeEx_Buf
!!

ALTER TRIGGER TR_FACIALACC_CLS_BU_500 active 
!!

commit work !!

/* ------------------------------------------------------ */
/*Alter_Trigger_TR_AGREEMENTS_BI_10.sql*/
/* ------------------------------------------------------ */



drop trigger TR_AGREEMENTS_BI_10
!!

commit work
!!

Create TRIGGER TR_AGREEMENTS_BI_10 FOR AGREEMENTS
ACTIVE BEFORE INSERT POSITION 10
as
declare variable    Tmp    integer;
declare variable    AdjID  integer;
declare variable    AdjDocNum varchar(150);
begin
/*  5.0*/

    /*   .*/
    if (new.InnerNumber is null) then
        exception EX_AGR_InnerNumsIsNull;

    /*   */
    select max(AdjustmentNumber)
        from Agreements
        where (InnerNumber = new.InnerNumber)
        into :Tmp;
    /*     ,   0*/
    if (Tmp is null) then
        new.AdjustmentNumber = 0;
    else
        new.AdjustmentNumber = Tmp + 1;

    /*       */
    if (((new.AgreementType = 0) and (new.AdjustmentNumber > 0)) or
        ((new.AgreementType = 1) and (new.AdjustmentNumber = 0))) then
        exception EX_AGR_AgrTypeViolation;

    /*       ,     */
    if ((new.Accepted = 0) and (new.AcceptDate is not null)) then
        new.LastAdjustment = 0;
    else
        new.LastAdjustment = 1;

    /*  ,       */
    if ((new.AcceptDate is not null) and (new.Accepted = 1)) then
        new.LastAccepted = 1;
    else
        new.LastAccepted = 0;

    /*   */
    if (new.AdjustmentNumber > 0) then
    begin
        /*     -    */
        select count(ID), max(ID), max(DocNumber)
            from Agreements
            where (InnerNumber = new.InnerNumber) and (LastAccepted = 1)
            into :Tmp, :AdjID, :AdjDocNum;
        /*  ,  */
        if (Tmp <> 1) then
            exception EX_AGR_AdjustNotAccept;
        /*        ,  */
        select count(ID)
            from Agreements
            where (InnerNumber = new.InnerNumber) and (AcceptDate is null)
            into :Tmp;
        if (Tmp > 0) then
           exception EX_AGR_AdjustDuplicate;
        /*,    ,    */
        new.AdjustmentRef = AdjID;
        new.AdjustmentDocNumber = AdjDocNum;
    end
    else /*    */
    begin
        /*      (    )*/
        new.AdjustmentRef = null;
        new.AdjustmentDocNumber = null;
    end
end
!!

commit work
!!



/* ------------------------------------------------------ */
/*Add_Fields_TenderCaption.sql*/
/* ------------------------------------------------------ */

/*    TenderCaption 
     AVersion -   ( ..  )
     ParentRef -   /   /
     :
     -  /    /
     -   /       /
     -       /     ( ,    )
     -     ParentRef 
    */

ALTER TABLE TenderCaption
  add AVersion     integer, /*   ( ..  ) */
  add ParentRef    NULLREF  /*   /   / */
!!

ALTER TABLE TenderCaption
   add constraint FK_Tender_ParentRef
       foreign key (ParentRef)
       references TenderCaption (ID),
   /*   /       / */
   add constraint CHK_Tender_ParentRef
       check (ParentRef is null or (ParentRef is not null and ProgIndex in (241, 243)))
!!

CREATE EXCEPTION EX_IncorrectTenderParentRef ' /    /'
!!

CREATE EXCEPTION EX_IncorrectAdjTenderParentRef '   /  /,      '
!!

CREATE EXCEPTION EX_ChangeAdjTenderParentRef '   /  / '
!!

commit work !!

/*    /  / */
CREATE OR ALTER TRIGGER TR_TENDERCAPTION_BI_30 FOR TENDERCAPTION
ACTIVE BEFORE INSERT POSITION 30
as
declare variable ParentProgIndex      integer;
declare variable ParentInnerNumber    integer;
declare variable AdjParentRef         integer;
declare variable AdjParentInnerNumber integer;
begin
  if (new.ParentRef is not null) then
  begin
    select ProgIndex, InnerNumber
    from TenderCaption
    where ID=new.ParentRef
    into :ParentProgIndex, :ParentInnerNumber;
    /* :  /    / */
    if  ((new.ProgIndex=243 and ParentProgIndex <> 242)
      or (new.ProgIndex=241 and ParentProgIndex <> 240))
    then exception EX_IncorrectTenderParentRef;
    /* :       /     ( ,    ) */
    if (new.AdjustmentRef is not null) then
    begin
      select ParentRef
      from TenderCaption
      where ID=new.AdjustmentRef
      into :AdjParentRef;
      if (AdjParentRef is not null) then
      begin
        select InnerNumber
        from TenderCaption
        where ID=:AdjParentRef
        into :AdjParentInnerNumber;
        if (AdjParentInnerNumber <> ParentInnerNumber) then
          exception EX_IncorrectAdjTenderParentRef;
      end
    end
  end
end
!!

/*    /  / */
CREATE OR ALTER TRIGGER TR_TENDERCAPTION_BU_30 FOR TENDERCAPTION
ACTIVE BEFORE UPDATE POSITION 30
as
declare variable ParentProgIndex      integer;
declare variable ParentInnerNumber    integer;
declare variable AdjParentRef         integer;
declare variable AdjParentInnerNumber integer;
begin
  /* :  /    / */
  if (new.ParentRef is not null
    /*  ,   */
    and  (old.ParentRef is null
      or (old.ParentRef is not null and old.ParentRef <> new.ParentRef)))
  then begin
    /* :     ParentRef  */
    if (new.LastAdjustment = 0) then
      exception EX_ChangeAdjTenderParentRef;
    select ProgIndex, InnerNumber
    from TenderCaption
    where ID=new.ParentRef
    into :ParentProgIndex, :ParentInnerNumber;
    /* :  /    / */
    if  ((new.ProgIndex=243 and ParentProgIndex <> 242)
      or (new.ProgIndex=241 and ParentProgIndex <> 240))
    then exception EX_IncorrectTenderParentRef;
    /* :       /     ( ,    ) */
    if (new.AdjustmentRef is not null) then
    begin
      select ParentRef
      from TenderCaption
      where ID=new.AdjustmentRef
      into :AdjParentRef;
      if (AdjParentRef is not null) then
      begin
        select InnerNumber
        from TenderCaption
        where ID=:AdjParentRef
        into :AdjParentInnerNumber;
        if (AdjParentInnerNumber <> ParentInnerNumber) then
          exception EX_IncorrectAdjTenderParentRef;
      end
    end
  end
end
!!

commit work !!


/* ------------------------------------------------------ */
/*ADD_AttributeName_DocumentFields.sql*/
/* ------------------------------------------------------ */


/*   " ",         */

ALTER TABLE DOCUMENTFIELDS
ADD ATTRIBUTENAME NOTE255
COLLATE PXW_CYRL 
!!

commit work
!!
/* ------------------------------------------------------ */
/*Update_AutosanctionData_Promise_from_Note1024_to_IntValue.sql*/
/* ------------------------------------------------------ */

/*     Promise  Note1024  IntValue   AUTOSANCTIONDATA. */

ALTER TRIGGER TR_AUTOSANCTIONDATA_BU_500 inactive 
!!

ALTER TABLE AUTOSANCTIONDATA
  add Promise_Buf Note1024
!!

update AUTOSANCTIONDATA
  set Promise_Buf = Promise
!!

ALTER TABLE AUTOSANCTIONDATA
  drop Promise,
  add Promise IntValue
!!

update AUTOSANCTIONDATA
  set Promise = 1 where Promise_Buf = ''
!!

update AUTOSANCTIONDATA
  set Promise = 0 where Promise_Buf is Null
!!


ALTER TABLE AUTOSANCTIONDATA
  drop Promise_Buf
!!

ALTER TRIGGER TR_AUTOSANCTIONDATA_BU_500 active 
!!

commit work !!


/* ------------------------------------------------------ */
/*Insert_RemoteDocument_30xx.sql*/
/* ------------------------------------------------------ */

/*          
   - ' '
   - '  '
   - '-'
    ' '  ' -' */

create procedure AddRemoteDocument(ID$ integer, Name$ varchar(1024))
as
DECLARE VARIABLE IDExists INTEGER;
BEGIN
  select count(ID) 
  from RemoteDocument 
  where (ID = :ID$)
  into :IDExists;

  if (:IDExists <> 0) then
    update RemoteDocument set Name = :Name$ where (ID = :ID$);
  else
    insert into RemoteDocument(ID, Name) values (:ID$, :Name$);
end
!!

execute procedure AddRemoteDocument(240, '-')
!!
execute procedure AddRemoteDocument(241, ' -')
!!
execute procedure AddRemoteDocument(242, ' ')
!!
execute procedure AddRemoteDocument(243, '  ')
!!

drop procedure AddRemoteDocument
!!

commit work
!!



/* ------------------------------------------------------ */
/*Add_SummaOtherYears_TenderProduct.sql*/
/* ------------------------------------------------------ */

/*    TenderProduct 
     SummaOtherYears -    
   */

ALTER TABLE TenderProduct
  add SummaOtherYears MONEY32 NOT NULL /*     */
!!

commit work !!

CREATE OR ALTER TRIGGER TR_TENDERPRODUCT_BI FOR TENDERPRODUCT BEFORE INSERT POSITION 0 as
begin
    if (new.id is null) then new.id = gen_id(g_Shared,1);
    if (new.SubKESR is null) then new.SubKESR = 0;
    if (new.KFSR is null) then new.KFSR = 0;
    if (new.KVSR is null) then new.KVSR = 0;
    if (new.KESR is null) then new.KESR = 0;
    if (new.KVR is null) then new.KVR = 0;
    if (new.KCSR is null) then new.KCSR = 0;
    if (new.FinSourceCls is null) then new.FinSourceCls = 0;
    if (new.FinType is null) then new.FinType = 0;
    if (new.TenderObjectCls is null) then new.TenderObjectCls = 0;
    if (new.FactCls is null) then new.FactCls = 0;
    if (new.OKATO is null) then new.OKATO = 0;
    if (new.MeansTypeCls is null) then new.MeansTypeCls = 0;
    if (new.DirectionCls is null) then new.DirectionCls = 0;
    if (new.AcceptPrice is null) then new.AcceptPrice = 0;
    if (new.PriceVAT is null) then new.PriceVAT = 0;
    if (new.AcceptAmount is null) then new.AcceptAmount = 0;
    if (new.AcceptMonth01 is null) then new.AcceptMonth01 = 0;
    if (new.AcceptMonth02 is null) then new.AcceptMonth02 = 0;
    if (new.AcceptMonth03 is null) then new.AcceptMonth03 = 0;
    if (new.AcceptMonth04 is null) then new.AcceptMonth04 = 0;
    if (new.AcceptMonth05 is null) then new.AcceptMonth05 = 0;
    if (new.AcceptMonth06 is null) then new.AcceptMonth06 = 0;
    if (new.AcceptMonth07 is null) then new.AcceptMonth07 = 0;
    if (new.AcceptMonth08 is null) then new.AcceptMonth08 = 0;
    if (new.AcceptMonth09 is null) then new.AcceptMonth09 = 0;
    if (new.AcceptMonth10 is null) then new.AcceptMonth10 = 0;
    if (new.AcceptMonth11 is null) then new.AcceptMonth11 = 0;
    if (new.AcceptMonth12 is null) then new.AcceptMonth12 = 0;
    if (new.AcceptQuarter1 is null) then new.AcceptQuarter1 = 0;
    if (new.AcceptQuarter2 is null) then new.AcceptQuarter2 = 0;
    if (new.AcceptQuarter3 is null) then new.AcceptQuarter3 = 0;
    if (new.AcceptQuarter4 is null) then new.AcceptQuarter4 = 0;
    if (new.AcceptSumma is null) then new.AcceptSumma = 0;
    if (new.DeliverySpec is null) then new.DeliverySpec = 0;
    if (new.DeliveryPeriod is null) then new.DeliveryPeriod = 0;
    if (new.DeliveryAmount is null) then new.DeliveryAmount = 0;
    if (new.VatPercent is null) then new.VatPercent = 0;
    if (new.AcceptVatSumma is null) then new.AcceptVatSumma = 0;
    if (new.AcceptCost is null) then new.AcceptCost = 0;
    if (new.AcceptTotalSumma is null) then new.AcceptTotalSumma = 0;
    if (new.Equivalent is null) then new.Equivalent = 0;
    if (new.SummaYear2 is null) then new.SummaYear2 = 0;
    if (new.SummaYear3 is null) then new.SummaYear3 = 0;
    if (new.SummaOtherYears is null) then new.SummaOtherYears = 0;
end
!!

CREATE OR ALTER TRIGGER TR_TENDERPRODUCT_BU_0 FOR TENDERPRODUCT BEFORE UPDATE POSITION 0 as
begin
    if (new.FacialAccCls is null) then new.FacialAccCls = 0;
    if (new.SubKESR is null) then new.SubKESR = 0;
    if (new.KFSR is null) then new.KFSR = 0;
    if (new.KVSR is null) then new.KVSR = 0;
    if (new.KESR is null) then new.KESR = 0;
    if (new.KVR is null) then new.KVR = 0;
    if (new.KCSR is null) then new.KCSR = 0;
    if (new.FinSourceCls is null) then new.FinSourceCls = 0;
    if (new.FinType is null) then new.FinType = 0;
    if (new.TenderObjectCls is null) then new.TenderObjectCls = 0;
    if (new.FactCls is null) then new.FactCls = 0;
    if (new.OKATO is null) then new.OKATO = 0;
    if (new.MeansTypeCls is null) then new.MeansTypeCls = 0;
    if (new.DirectionCls is null) then new.DirectionCls = 0;
    if (new.AcceptPrice is null) then new.AcceptPrice = 0;
    if (new.PriceVAT is null) then new.PriceVAT = 0;
    if (new.AcceptAmount is null) then new.AcceptAmount = 0;
    if (new.AcceptMonth01 is null) then new.AcceptMonth01 = 0;
    if (new.AcceptMonth02 is null) then new.AcceptMonth02 = 0;
    if (new.AcceptMonth03 is null) then new.AcceptMonth03 = 0;
    if (new.AcceptMonth04 is null) then new.AcceptMonth04 = 0;
    if (new.AcceptMonth05 is null) then new.AcceptMonth05 = 0;
    if (new.AcceptMonth06 is null) then new.AcceptMonth06 = 0;
    if (new.AcceptMonth07 is null) then new.AcceptMonth07 = 0;
    if (new.AcceptMonth08 is null) then new.AcceptMonth08 = 0;
    if (new.AcceptMonth09 is null) then new.AcceptMonth09 = 0;
    if (new.AcceptMonth10 is null) then new.AcceptMonth10 = 0;
    if (new.AcceptMonth11 is null) then new.AcceptMonth11 = 0;
    if (new.AcceptMonth12 is null) then new.AcceptMonth12 = 0;
    if (new.AcceptQuarter1 is null) then new.AcceptQuarter1 = 0;
    if (new.AcceptQuarter2 is null) then new.AcceptQuarter2 = 0;
    if (new.AcceptQuarter3 is null) then new.AcceptQuarter3 = 0;
    if (new.AcceptQuarter4 is null) then new.AcceptQuarter4 = 0;
    if (new.AcceptSumma is null) then new.AcceptSumma = 0;
    if (new.DeliverySpec is null) then new.DeliverySpec = 0;
    if (new.DeliveryPeriod is null) then new.DeliveryPeriod = 0;
    if (new.DeliveryAmount is null) then new.DeliveryAmount = 0;
    if (new.VatPercent is null) then new.VatPercent = 0;
    if (new.AcceptVatSumma is null) then new.AcceptVatSumma = 0;
    if (new.AcceptCost is null) then new.AcceptCost = 0;
    if (new.AcceptTotalSumma is null) then new.AcceptTotalSumma = 0;
    if (new.Equivalent is null) then new.Equivalent = 0;    
    if (new.SummaYear2 is null) then new.SummaYear2 = 0;
    if (new.SummaYear3 is null) then new.SummaYear3 = 0;
    if (new.SummaOtherYears is null) then new.SummaOtherYears = 0;
end
!!

commit work !!


/* ------------------------------------------------------ */
/*alter_fix_TR_KD_BD_0.sql*/
/* ------------------------------------------------------ */

/*      .          ExtID */

ALTER trigger tr_kd_bd_0
as
begin
  /*    ,      */
  if (old.kvsr = 0) then
    if (exists ( select *
                 from kd kd1
                 where (kd1.kvsr <> 0) and
                       ((kd1.descriptioncode-old.descriptioncode>-1) and (kd1.descriptioncode-old.descriptioncode<1)) and
                       (kd1.programcode = old.programcode) and
                       (kd1.AnalyticalGroupKD = old.AnalyticalGroupKD) and
                       (kd1.BudgetRef = old.BudgetRef) and
                       ((kd1.ExtID = old.ExtID)or((old.ExtID is null)and(old.ExtID is null)))
       )) 
    then
      exception EX_CANTDELBASECODE;
end
!!

ALTER trigger tr_innerfinsource_bd_0
as
begin
  /*    ,      */
  if (old.kvsr = 0) then
    if (exists ( select *
                 from InnerFinSource ifs1
                 where (ifs1.kvsr <> 0) and
                       ((ifs1.descriptioncode-old.descriptioncode>-1) and (ifs1.descriptioncode-old.descriptioncode<1)) and
                       (ifs1.AnalyticalGroupIFS = old.AnalyticalGroupIFS) and
                       (ifs1.BudgetRef = old.BudgetRef) and
                       ((ifs1.ExtID = old.ExtID)or((ifs1.ExtID is null)and(old.ExtID is null)))
       )) 
    then
      exception EX_CANTDELBASECODE;
end
!!

commit work !!


/* ------------------------------------------------------ */
/*UpdDocFields_11.30.00.sql*/
/* ------------------------------------------------------ */

/*  : 113000 - 113000.     25.08.2016 13:18:14. */

CREATE PROCEDURE ImportDocType (
   ID_               INTEGER,
   PROGINDEX_        INTEGER,
   NAME_             VARCHAR(255),
   USESTATE_         INTEGER,
   DBTABLE_          VARCHAR(255),
   NEEDEDS_          INTEGER,
   LOCKMASK_         INTEGER,
   DEFAULTACTIONMACROSNAME_ VARCHAR(255),
   DOCUMENTKIND_     INTEGER,
   SHORTNAME_         VARCHAR(255)
) AS
DECLARE VARIABLE IDExists INTEGER;
BEGIN
   SELECT COUNT (ID)
     FROM DocumentTypes
    WHERE (ID = :ID_)
     INTO :IDExists;

   IF (:IDExists = 0) THEN
      INSERT INTO DocumentTypes
                  (ID, PROGINDEX, NAME, USESTATE, DBTABLE, NEEDEDS, LOCKMASK, DEFAULTACTIONMACROSNAME, DOCUMENTKIND,SHORTNAME)
           VALUES (:ID_, :PROGINDEX_, :NAME_, :USESTATE_, :DBTABLE_, :NEEDEDS_, :LOCKMASK_, :DEFAULTACTIONMACROSNAME_, :DOCUMENTKIND_, :SHORTNAME_);
    else
      Update documenttypes set
        Name=:Name_,
        DBTABLE=:DBTABLE_,
        LockMask=:LockMask_,
        DEFAULTACTIONMACROSNAME=:DEFAULTACTIONMACROSNAME_,
        DOCUMENTKIND = :DOCUMENTKIND_,
        SHORTNAME = :SHORTNAME_,
        PROGINDEX = :PROGINDEX_
      where (id=:ID_)
        and (
          (Name<>:Name_) or 
          ((LockMask is null) and (:LOCKMASK_ is not null)) or
          ((LockMask is not null) and (:LOCKMASK_ is null)) or
          ((LockMask is not null) and (:LOCKMASK_ is not null) and (LockMask <> :LOCKMASK_)) or
          (DEFAULTACTIONMACROSNAME is null) or
          (DOCUMENTKIND<>:DOCUMENTKIND_) or 
          (SHORTNAME is null) or 
          (SHORTNAME<>:SHORTNAME_) OR 
          (PROGINDEX <> :PROGINDEX_) OR
          ((DBTABLE is null) and (:DBTABLE_ is not null)) or
          ((DBTABLE is not null) and (:DBTABLE_ is null)) or
          ((DBTABLE is not null) and (:DBTABLE_ is not null) and (DBTABLE <> :DBTABLE_))
        );          
END
!!

CREATE PROCEDURE UPDATEINTERFACES (
  CLS_   INTEGER,
  NOTE_  VARCHAR(255),
  GUID_  VARCHAR(50),
  PARAM_ VARCHAR(255)
) AS
DECLARE VARIABLE IDExists INTEGER;
BEGIN
  SELECT COUNT (ID)
    FROM INTERFACES
  WHERE 
   (GUID=:GUID_)
   INTO :IDEXISTS;
  
  IF (:IDExists = 0)  THEN
  BEGIN
    IF (:PARAM_ = '') THEN PARAM_ = NULL;
    INSERT INTO INTERFACES
      (CLS,NOTE,GUID,PARAM)
    VALUES
      (:CLS_,:NOTE_,:GUID_,:PARAM_);  
  END
  ELSE
  BEGIN
    IF ((:PARAM_ = '')OR((:PARAM_ IS NULL))) THEN 
    UPDATE INTERFACES SET
      CLS = :CLS_
    WHERE (GUID=:GUID_) AND ((CLS<> :CLS_)OR(CLS IS NULL));
    ELSE 
    UPDATE INTERFACES SET
      CLS = :CLS_
    WHERE (GUID=:GUID_) AND (PARAM=:PARAM_) AND ((CLS<> :CLS_)OR(CLS IS NULL));
  END  
END
!!

/*    */
EXECUTE PROCEDURE ImportDocType(200, 0, '  ()', 0, '', 0,0,'',30000,'') !!
EXECUTE PROCEDURE ImportDocType(323, 75, ' ', 0, 'FacialFinCaption', 0,-1,'_',10100,'') !!
EXECUTE PROCEDURE ImportDocType(324, 76, ' ', 0, 'FacialFinCaption', 0,-1,'_',10100,'') !!
EXECUTE PROCEDURE ImportDocType(906, 41, '  ()', 0, ' ', 0,-1,'',10200,'_') !!
EXECUTE PROCEDURE ImportDocType(2504, 314, ' ', 0, 'Agreements', 0,-65537,'',10100,'') !!
EXECUTE PROCEDURE ImportDocType(3001, 230, '   ', 0, 'TenderCaption', 0,-65537,'',10100,'') !!
EXECUTE PROCEDURE ImportDocType(3005, 240, '-', 0, 'TenderCaption', 0,127,'',10100,'') !!
EXECUTE PROCEDURE ImportDocType(3006, 241, ' -', 0, 'TenderCaption', 0,-65537,'',10100,'') !!
EXECUTE PROCEDURE ImportDocType(3010, 242, ' ', 0, 'TenderCaption', 0,-1,'',10100,'') !!
EXECUTE PROCEDURE ImportDocType(3011, 243, '  ', 0, 'TenderCaption', 0,-1,'',10100,'') !!
EXECUTE PROCEDURE ImportDocType(5501, 312, '   ', 0, 'CorrectionCaption', 0,-1,'',10100,'_') !!
EXECUTE PROCEDURE ImportDocType(5502, 313, '   ', 0, 'CorrectionCaption', 0,-1,'',10100,'_') !!
EXECUTE PROCEDURE ImportDocType(5503, 0, '   ', 0, 'ReplacementClsCaption', 0,-1,'',10100,'') !!
EXECUTE PROCEDURE UpdateInterfaces(5503, '   ', '{6110B8B7-DFE8-46EF-BD9F-39CCF092BB79}', '') !!
EXECUTE PROCEDURE ImportDocType(9930, 0, '   ', 0, 'AutoSanctionData', 0,0,'',10200,'') !!
EXECUTE PROCEDURE UpdateInterfaces(9930, '   ', '{23B8DC44-93C1-48C2-B2EB-DCAF31C23929}', '') !!

DROP PROCEDURE ImportDocType !!

DROP PROCEDURE UPDATEINTERFACES !!


CREATE PROCEDURE SELECTIONS_IMPORT(
  ID INTEGER,
  KIND INTEGER,
  NAME VARCHAR(30),
  NOTE VARCHAR(255),
  READONLY INTEGER,
  USEINDOC INTEGER,
  TABLENAME VARCHAR(30),
  ALIAS VARCHAR(30),
  TABLECODE INTEGER,
  NEEDGROUPONDB INTEGER,
  NEEDDISTINCT INTEGER,
  MASTER INTEGER,
  DISCRIMVALUE VARCHAR(255),
  AVAILABLEINDEREF INTEGER,
  CACHETYPE INTEGER,
  FULLORMODINSREFRTIME INTEGER,
  DELETEREFRTIME INTEGER,
  FINDTIMEREFRESH INTEGER,
  ANNOTATION VARCHAR(1024),
  DEREFNAME VARCHAR(30),
  GroupID INTEGER,
  IsLogged INTEGER
) AS
BEGIN
  IF (EXISTS (
    SELECT ID FROM SELECTIONS SL
    WHERE SL.ID = :ID ))
  THEN
  BEGIN
    UPDATE SELECTIONS SET
      KIND = :KIND,
      NAME = :NAME,
      NOTE = :NOTE,
      READONLY = :READONLY,
      USEINDOC = :USEINDOC,
      TABLENAME = :TABLENAME,
      ALIAS = :ALIAS,
      TABLECODE = :TABLECODE,    
      NEEDGROUPONDB = :NEEDGROUPONDB,
      NEEDDISTINCT = :NEEDDISTINCT,
      MASTER = :MASTER,
      DISCRIMVALUE = :DISCRIMVALUE,
      AVAILABLEINDEREF = :AVAILABLEINDEREF,
      CACHETYPE = :CACHETYPE,
      FULLORMODINSREFRTIME = :FULLORMODINSREFRTIME,
      DELETEREFRTIME = :DELETEREFRTIME,
      FINDTIMEREFRESH = :FINDTIMEREFRESH,
      ANNOTATION = :ANNOTATION,     
      DEREFNAME = :DEREFNAME,
      GroupID = :GroupID,
      IsLogged = :IsLogged       
    WHERE ID = :ID;
  END ELSE
  BEGIN
    INSERT INTO SELECTIONS
      (ID, KIND, NAME, NOTE, READONLY, USEINDOC, TABLENAME, ALIAS, TABLECODE, NEEDGROUPONDB, NEEDDISTINCT, MASTER, DISCRIMVALUE,
      AVAILABLEINDEREF, CACHETYPE, FULLORMODINSREFRTIME, DELETEREFRTIME, FINDTIMEREFRESH, ANNOTATION, DEREFNAME, GroupID, IsLogged)
    VALUES
      (:ID, :KIND, :NAME, :NOTE, :READONLY, :USEINDOC, :TABLENAME, :ALIAS, :TABLECODE, :NEEDGROUPONDB, :NEEDDISTINCT, :MASTER, :DISCRIMVALUE,
      :AVAILABLEINDEREF, :CACHETYPE, :FULLORMODINSREFRTIME, :DELETEREFRTIME, :FINDTIMEREFRESH, :ANNOTATION, :DEREFNAME, :GroupID, :IsLogged);
  END
END
!!

CREATE PROCEDURE SELECTIONSDETAIL_IMPORT(
  ID INTEGER,
  SELECTIONREF INTEGER,
  TABLEREF INTEGER,
  ALIAS VARCHAR(30),
  JOINORDER INTEGER,
  JOINTYPE INTEGER,
  RELATIONTYPE INTEGER,
  JOINCONDITION VARCHAR(255),
  DONTUSETABLELIMITS INTEGER,
  LIMITNAMESLIST VARCHAR(255),
  QueryGroup INTEGER 
) AS
BEGIN
  IF (EXISTS (
    SELECT ID FROM SELECTIONSDETAIL SLD
    WHERE SLD.ID = :ID ))
  THEN
  BEGIN
    UPDATE SELECTIONSDETAIL SET
      SELECTIONREF = :SELECTIONREF,
      TABLEREF = :TABLEREF,
      ALIAS = :ALIAS,
      JOINORDER = :JOINORDER,
      JOINTYPE = :JOINTYPE,
      RELATIONTYPE = :RELATIONTYPE,
      JOINCONDITION = :JOINCONDITION,
      DONTUSETABLELIMITS = :DONTUSETABLELIMITS,
      LIMITNAMESLIST = :LIMITNAMESLIST,
      QueryGroup = :QueryGroup
    WHERE ID = :ID;
  END ELSE
  BEGIN
    INSERT INTO SELECTIONSDETAIL
      (ID, SELECTIONREF, TABLEREF, ALIAS, JOINORDER, JOINTYPE, RELATIONTYPE, JOINCONDITION, DONTUSETABLELIMITS, LIMITNAMESLIST, QueryGroup)
    VALUES
      (:ID, :SELECTIONREF, :TABLEREF, :ALIAS, :JOINORDER, :JOINTYPE, :RELATIONTYPE, :JOINCONDITION, :DONTUSETABLELIMITS, :LIMITNAMESLIST, :QueryGroup);
  END
END
!!

CREATE PROCEDURE FIELDSINFO_IMPORT(
  ID INTEGER,
  FIELDKIND INTEGER,
  DESCRIPTIONLEVEL INTEGER,
  ANCESTORREF INTEGER,
  SELECTIONREF INTEGER,
  TABLEREF INTEGER,
  FIELDNAME VARCHAR(50),
  DATATYPE INTEGER,
  SUBDATATYPE INTEGER,
  FIELDSIZE INTEGER,
  DISPLAYLABEL VARCHAR(80),
  NOTE VARCHAR(255),
  DEFAULTWIDTH INTEGER,
  EDITMASK VARCHAR(80),
  DISPLAYFORMAT VARCHAR(80),
  EDITFORMAT VARCHAR(80),
  CANTEDIT INTEGER,
  NOVISUALIZE INTEGER,
  ENUMSREF INTEGER,
  REQUIRED INTEGER,
  FOREIGNKEY INTEGER,
  ONDELACTION INTEGER,
  PRIMARYKEY INTEGER,
  ISRVERSION INTEGER,
  LIMITPARAMNAMES VARCHAR(255),
  FOLLOWORDER INTEGER,
  SORTDIRECTION INTEGER,
  SORTORDER INTEGER,
  AGRFUNCTION INTEGER,
  FLAGFIELDNAME INTEGER,
  FLAGDISPLAYLABEL INTEGER,
  FLAGNOTE INTEGER,
  FLAGDEFAULTWIDTH INTEGER,
  FLAGCANTEDIT INTEGER,
  FLAGNOVISUALIZE INTEGER,
  FLAGREQUIRED INTEGER,
  FLAGLIMITPARAMNAMES INTEGER,
  FLAGAGRFUNCTION INTEGER,
  ISTIMESTAMPFIELD INTEGER,
  ISBUDGET INTEGER,
  AVAILABLEINDEREF INTEGER,
  ANNOTATION VARCHAR(1024),
  ALIAS VARCHAR(30),
  DEREFNAME VARCHAR(30)
) AS
BEGIN
  IF (EXISTS (
    SELECT ID FROM FIELDSINFO FI
    WHERE FI.ID = :ID ))
  THEN
  BEGIN
    UPDATE FIELDSINFO SET
      FIELDKIND = :FIELDKIND,
      DESCRIPTIONLEVEL = :DESCRIPTIONLEVEL,
      ANCESTORREF = :ANCESTORREF,
      SELECTIONREF = :SELECTIONREF,
      TABLEREF = :TABLEREF,
      FIELDNAME = :FIELDNAME,
      DATATYPE = :DATATYPE,
      SUBDATATYPE = :SUBDATATYPE,
      FIELDSIZE = :FIELDSIZE,
      DISPLAYLABEL = :DISPLAYLABEL,
      NOTE = :NOTE,
      DEFAULTWIDTH = :DEFAULTWIDTH,
      EDITMASK = :EDITMASK,
      DISPLAYFORMAT = :DISPLAYFORMAT,
      EDITFORMAT = :EDITFORMAT,
      CANTEDIT = :CANTEDIT,
      NOVISUALIZE = :NOVISUALIZE,
      ENUMSREF = :ENUMSREF,
      REQUIRED = :REQUIRED,
      FOREIGNKEY = :FOREIGNKEY,
      ONDELACTION = :ONDELACTION,
      PRIMARYKEY = :PRIMARYKEY,
      ISRVERSION = :ISRVERSION,
      LIMITPARAMNAMES = :LIMITPARAMNAMES,
      FOLLOWORDER = :FOLLOWORDER,
      SORTDIRECTION = :SORTDIRECTION,
      SORTORDER = :SORTORDER,
      AGRFUNCTION = :AGRFUNCTION,
      FLAGFIELDNAME = :FLAGFIELDNAME,
      FLAGDISPLAYLABEL = :FLAGDISPLAYLABEL,
      FLAGNOTE = :FLAGNOTE,
      FLAGDEFAULTWIDTH = :FLAGDEFAULTWIDTH,
      FLAGCANTEDIT = :FLAGCANTEDIT,
      FLAGNOVISUALIZE = :FLAGNOVISUALIZE,
      FLAGREQUIRED = :FLAGREQUIRED,
      FLAGLIMITPARAMNAMES = :FLAGLIMITPARAMNAMES,
      FLAGAGRFUNCTION = :FLAGAGRFUNCTION,
      ISTIMESTAMPFIELD = :ISTIMESTAMPFIELD,
      ISBUDGET = :ISBUDGET,
      AVAILABLEINDEREF = :AVAILABLEINDEREF,
      ANNOTATION = :ANNOTATION,
      ALIAS = :ALIAS,
      DEREFNAME = :DEREFNAME
    WHERE ID = :ID;
  END ELSE
  BEGIN
    INSERT INTO FIELDSINFO
      (ID, FIELDKIND, DESCRIPTIONLEVEL, ANCESTORREF, SELECTIONREF, TABLEREF, FIELDNAME, DATATYPE, SUBDATATYPE,
       FIELDSIZE, DISPLAYLABEL, NOTE, DEFAULTWIDTH, EDITMASK, DISPLAYFORMAT, EDITFORMAT, CANTEDIT, NOVISUALIZE,
       ENUMSREF, REQUIRED, FOREIGNKEY, ONDELACTION, PRIMARYKEY, ISRVERSION, LIMITPARAMNAMES,
       FOLLOWORDER, SORTDIRECTION, SORTORDER, AGRFUNCTION, FLAGFIELDNAME, FLAGDISPLAYLABEL, FLAGNOTE,
       FLAGDEFAULTWIDTH, FLAGCANTEDIT, FLAGNOVISUALIZE, FLAGREQUIRED, FLAGLIMITPARAMNAMES, FLAGAGRFUNCTION,
       ISTIMESTAMPFIELD, ISBUDGET, AVAILABLEINDEREF, ANNOTATION, ALIAS, DEREFNAME)
    VALUES
      (:ID, :FIELDKIND, :DESCRIPTIONLEVEL, :ANCESTORREF, :SELECTIONREF, :TABLEREF, :FIELDNAME, :DATATYPE, :SUBDATATYPE,
       :FIELDSIZE, :DISPLAYLABEL, :NOTE, :DEFAULTWIDTH, :EDITMASK, :DISPLAYFORMAT, :EDITFORMAT, :CANTEDIT, :NOVISUALIZE,
       :ENUMSREF, :REQUIRED, :FOREIGNKEY, :ONDELACTION, :PRIMARYKEY, :ISRVERSION, :LIMITPARAMNAMES,
       :FOLLOWORDER, :SORTDIRECTION, :SORTORDER, :AGRFUNCTION, :FLAGFIELDNAME, :FLAGDISPLAYLABEL, :FLAGNOTE,
       :FLAGDEFAULTWIDTH, :FLAGCANTEDIT, :FLAGNOVISUALIZE, :FLAGREQUIRED, :FLAGLIMITPARAMNAMES, :FLAGAGRFUNCTION,
       :ISTIMESTAMPFIELD, :ISBUDGET, :AVAILABLEINDEREF, :ANNOTATION, :ALIAS, :DEREFNAME);
  END
END
!!

CREATE PROCEDURE SELECTIONEVENTS_IMPORT(
  ID INTEGER,
  SELECTIONREF INTEGER,
  EVENTCODE INTEGER,
  SCRIPTNAME VARCHAR(255)
) AS
BEGIN
  IF (EXISTS (
    SELECT ID FROM SELECTIONEVENTS SE
    WHERE SE.ID = :ID ))
  THEN
  BEGIN
    UPDATE SELECTIONEVENTS SET
      SELECTIONREF = :SELECTIONREF,
      EVENTCODE = :EVENTCODE,
      SCRIPTNAME = :SCRIPTNAME
    WHERE ID = :ID;
  END ELSE
  BEGIN
    INSERT INTO SELECTIONEVENTS
      (ID, SELECTIONREF, EVENTCODE, SCRIPTNAME)
    VALUES
      (:ID, :SELECTIONREF, :EVENTCODE, :SCRIPTNAME);
  END
END
!!

CREATE PROCEDURE FIELDSINFO_DELETE(
  ID INTEGER
) AS
BEGIN
  UPDATE DOCUMENTFIELDS SET
    FIELDINFOREF = NULL
  WHERE FIELDINFOREF = :ID;
  DELETE FROM FIELDSINFO FI
  WHERE FI.ID = :ID;
END
!!

CREATE PROCEDURE SELECTIONSDETAIL_DELETE(
  ID INTEGER
) AS
BEGIN
  DELETE FROM SELECTIONSDETAIL SLD
  WHERE SLD.ID = :ID;
END
!!

CREATE PROCEDURE SELECTIONS_DELETE(
  ID INTEGER
) AS
BEGIN
  DELETE FROM SELECTIONS SL
  WHERE SL.ID = :ID;
END
!!

CREATE PROCEDURE SELECTIONEVENTS_DELETE(
  ID INTEGER
) AS
BEGIN
  DELETE FROM SELECTIONEVENTS SE
  WHERE SE.ID = :ID;
END
!!

/*  */
/*   */

DROP PROCEDURE SELECTIONS_IMPORT !!
DROP PROCEDURE SELECTIONSDETAIL_IMPORT !!
DROP PROCEDURE FIELDSINFO_IMPORT !!
DROP PROCEDURE SELECTIONEVENTS_IMPORT !!

DROP PROCEDURE FIELDSINFO_DELETE !!
DROP PROCEDURE SELECTIONSDETAIL_DELETE !!
DROP PROCEDURE SELECTIONS_DELETE !!
DROP PROCEDURE SELECTIONEVENTS_DELETE !!

CREATE PROCEDURE ImportDocCLS (
   ID_                 INTEGER,
   DOCTYPE_            INTEGER,
   DOCTYPENOTE_        VARCHAR(255),
   TABLENAME_          VARCHAR(30),
   TABLENAMEURM_       VARCHAR(30),
   PRIMARYKEYNAME_     VARCHAR(255),
   PRIMARYKEYNAMEURM_  VARCHAR(255),
   LINKFIELDNAME_      VARCHAR(255),
   LINKFIELDNAMEURM_   VARCHAR(255),
   CLSTYPE_            INTEGER,
   SELECTIONREFBUDGET_ INTEGER,
   SELECTIONREFURM_    INTEGER,
   PROGINDEX_          INTEGER    
) AS
DECLARE VARIABLE IDExists INTEGER;
BEGIN
   SELECT COUNT (ID)
   FROM DOCUMENTCLS
   WHERE (ID = :ID_)
   INTO :IDExists;
   IF (:IDExists = 0) THEN
   INSERT INTO DOCUMENTCLS
   (ID, DOCTYPE, DOCTYPENOTE, TABLENAME, TABLENAMEURM, PRIMARYKEYNAME, PRIMARYKEYNAMEURM, LINKFIELDNAME, LINKFIELDNAMEURM, 
     CLSTYPE, SELECTIONREFBUDGET, SELECTIONREFURM, PROGINDEX)
   VALUES (:ID_, :DOCTYPE_, :DOCTYPENOTE_, :TABLENAME_, :TABLENAMEURM_, :PRIMARYKEYNAME_, :PRIMARYKEYNAMEURM_, :LINKFIELDNAME_, :LINKFIELDNAMEURM_, 
     :CLSTYPE_, :SELECTIONREFBUDGET_, :SELECTIONREFURM_, :PROGINDEX_);
   ELSE
   UPDATE DOCUMENTCLS 
   SET
     DOCTYPENOTE = :DOCTYPENOTE_,
     TABLENAME = :TABLENAME_,
     TABLENAMEURM = :TABLENAMEURM_,
     PRIMARYKEYNAME = :PRIMARYKEYNAME_,
     PRIMARYKEYNAMEURM = :PRIMARYKEYNAMEURM_,
     LINKFIELDNAME = :LINKFIELDNAME_,
     LINKFIELDNAMEURM = :LINKFIELDNAMEURM_,
     CLSTYPE = :CLSTYPE_,
     SELECTIONREFBUDGET = :SELECTIONREFBUDGET_,
     SELECTIONREFURM = :SELECTIONREFURM_,
     PROGINDEX = :PROGINDEX_
   WHERE  
    (ID = :ID_)
    AND NOT (
            (
                    ((DOCTYPENOTE IS NOT NULL AND :DOCTYPENOTE_ IS NOT NULL) AND
                       (UPPER (DOCTYPENOTE) = UPPER (:DOCTYPENOTE_))
                    )
                    OR (DOCTYPENOTE IS NULL AND :DOCTYPENOTE_ IS NULL)
                )    
        AND (UPPER (TABLENAME) = UPPER (:TABLENAME_))    
        AND (
                    ((TABLENAMEURM IS NOT NULL AND :TABLENAMEURM_ IS NOT NULL) AND
                       (UPPER (TABLENAMEURM) = UPPER (:TABLENAMEURM_))
                    )
                    OR (TABLENAMEURM IS NULL AND :TABLENAMEURM_ IS NULL)
                )    
        AND (UPPER (PRIMARYKEYNAME) = UPPER (:PRIMARYKEYNAME_))
        AND (
                    ((PRIMARYKEYNAMEURM IS NOT NULL AND :PRIMARYKEYNAMEURM_ IS NOT NULL) AND
                       (UPPER (PRIMARYKEYNAMEURM) = UPPER (:PRIMARYKEYNAMEURM_))
                    )
                    OR (PRIMARYKEYNAMEURM IS NULL AND :PRIMARYKEYNAMEURM_ IS NULL)
                )    
        AND (
                    ((LINKFIELDNAME IS NOT NULL AND :LINKFIELDNAME_ IS NOT NULL) AND
                       (UPPER (LINKFIELDNAME) = UPPER (:LINKFIELDNAME_))
                    )
                    OR (LINKFIELDNAME IS NULL AND :LINKFIELDNAME_ IS NULL)
                )    
        AND (
                    ((LINKFIELDNAMEURM IS NOT NULL AND :LINKFIELDNAMEURM_ IS NOT NULL) AND
                       (UPPER (LINKFIELDNAMEURM) = UPPER (:LINKFIELDNAMEURM_))
                    )
                    OR (LINKFIELDNAMEURM IS NULL AND :LINKFIELDNAMEURM_ IS NULL)
                )    
        AND (
                    ((CLSTYPE IS NOT NULL AND :CLSTYPE_ IS NOT NULL) AND
                       (UPPER (CLSTYPE) = UPPER (:CLSTYPE_))
                    )
                    OR (CLSTYPE IS NULL AND :CLSTYPE_ IS NULL)
                ) 
        AND (
                    ((PROGINDEX IS NOT NULL AND :PROGINDEX_ IS NOT NULL) AND
                       (PROGINDEX = :PROGINDEX_)
                    )
                    OR (PROGINDEX IS NULL AND :PROGINDEX_ IS NULL)
                )    
            );
END
!!

/*    */
EXECUTE PROCEDURE ImportDocCLS(32300, 323, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 75) !!
EXECUTE PROCEDURE ImportDocCLS(32301, 323, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 75) !!
EXECUTE PROCEDURE ImportDocCLS(32400, 324, '', 'FACIALFINCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 76) !!
EXECUTE PROCEDURE ImportDocCLS(32401, 324, '', 'FACIALFINDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 76) !!
EXECUTE PROCEDURE ImportDocCLS(90600, 906, '', 'INCOMES32', ' ', 'ID', ' ', '', ' ', 0, null, null, 41) !!
EXECUTE PROCEDURE ImportDocCLS(90601, 906, '', 'INCOMES32', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 42) !!
EXECUTE PROCEDURE ImportDocCLS(550100, 5501, '', 'CORRECTIONCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 312) !!
EXECUTE PROCEDURE ImportDocCLS(550101, 5501, '', 'CORRECTIONDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 312) !!
EXECUTE PROCEDURE ImportDocCLS(550200, 5502, '', 'CORRECTIONCAPTION', ' ', 'ID', ' ', '', ' ', 0, null, null, 313) !!
EXECUTE PROCEDURE ImportDocCLS(550201, 5502, '', 'CORRECTIONDETAIL', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, 313) !!
EXECUTE PROCEDURE ImportDocCLS(991600, 9916, '', ' ', ' ', ' ', ' ', '', '', 0, null, null, null) !!
EXECUTE PROCEDURE ImportDocCLS(20000, 200, '', 'BUDNOTIFY', ' ', 'id', ' ', '', '', 0, null, null, null) !!
EXECUTE PROCEDURE ImportDocCLS(20001, 200, '', 'BUDGETDATA', ' ', 'id', ' ', 'RECORDINDEX', '', 0, null, null, null) !!
EXECUTE PROCEDURE ImportDocCLS(250400, 2504, '', 'AGREEMENTS', 'AGREEMENTS', 'ID', 'ID', '', '', 0, null, null, 314) !!
EXECUTE PROCEDURE ImportDocCLS(300100, 3001, '', 'TenderCaption', ' ', 'ID', ' ', '', '', 0, null, null, 230) !!
EXECUTE PROCEDURE ImportDocCLS(250401, 2504, '  ', 'AGREEMENTSTEPS', 'AGREEMENTSTEPS', 'ID', 'ID', 'RECORDINDEX', 'RECORDINDEX', 0, null, null, null) !!
EXECUTE PROCEDURE ImportDocCLS(250402, 2504, '   ', 'PAYMENTSCHEDULE', 'PAYMENTSCHEDULE', 'ID', 'ID', 'AGREEMENTREF', 'AGREEMENTREF', 0, null, null, 314) !!
EXECUTE PROCEDURE ImportDocCLS(250403, 2504, '  ', 'ESTIMATE', 'ESTIMATE', 'ID', 'ID', 'RECORDINDEX', 'RECORDINDEX', 0, null, null, null) !!
EXECUTE PROCEDURE ImportDocCLS(300600, 3006, '', 'TENDERCAPTION', ' ', 'ID', ' ', '', '', 0, null, null, 241) !!
EXECUTE PROCEDURE ImportDocCLS(300601, 3006, '  ', 'TENDERPRODUCT', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 241) !!
EXECUTE PROCEDURE ImportDocCLS(300602, 3006, '   ', 'TENDERCONTACTS', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) !!
EXECUTE PROCEDURE ImportDocCLS(300101, 3001, ' ', 'TenderProduct', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 230) !!
EXECUTE PROCEDURE ImportDocCLS(300102, 3001, ' ', 'TenderLot', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) !!
EXECUTE PROCEDURE ImportDocCLS(300103, 3001, '   ', 'TENDERSOURCEORG', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) !!
EXECUTE PROCEDURE ImportDocCLS(300104, 3001, '   ', 'TENDERYARDSTICKS', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) !!
EXECUTE PROCEDURE ImportDocCLS(300105, 3001, '   ', 'TENDERYARDSTICKS', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) !!
EXECUTE PROCEDURE ImportDocCLS(300106, 3001, ' ', 'TENDERCONTACTS', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) !!
EXECUTE PROCEDURE ImportDocCLS(300107, 3001, '   ', 'TENDERSUPPLEMENTS', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) !!
EXECUTE PROCEDURE ImportDocCLS(300108, 3001, ',  ', 'TENDERSUPDOCUMENT', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) !!
EXECUTE PROCEDURE ImportDocCLS(550300, 5503, '', 'ReplacementClsCaption', ' ', 'ID', ' ', '', '', 0, null, null, null) !!
EXECUTE PROCEDURE ImportDocCLS(550301, 5503, '   ', 'ReplacementClsDetail', ' ', 'ID', ' ', 'RECORDINDEX', ' ', 0, null, null, null) !!
EXECUTE PROCEDURE ImportDocCLS(550302, 5503, ' ', 'ReplacementClsDetailInfo', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, null) !!
EXECUTE PROCEDURE ImportDocCLS(250404, 2504, ' ', 'EXECUTIONDOCUMENTSCAPTION', 'EXECUTIONDOCUMENTSCAPTION', 'ID', 'ID', '', '', 0, null, null, null) !!
EXECUTE PROCEDURE ImportDocCLS(250405, 2504, ' ', 'PAYMENTSCHEDULE', 'PAYMENTSCHEDULE', 'ID', 'ID', 'RECORDINDEX', '', 0, null, null, null) !!
EXECUTE PROCEDURE ImportDocCLS(993000, 9930, '', 'AUTOSANCTIONDATA', ' ', 'ID', ' ', '', '', 0, null, null, null) !!
EXECUTE PROCEDURE ImportDocCLS(301000, 3010, '', 'TENDERCAPTION', ' ', 'ID', ' ', '', '', 0, null, null, 242) !!
EXECUTE PROCEDURE ImportDocCLS(301100, 3011, '', 'TENDERCAPTION', ' ', 'ID', ' ', '', '', 0, null, null, 242) !!
EXECUTE PROCEDURE ImportDocCLS(301101, 3011, ' ', 'TENDERPRODUCT', ' ', 'ID', ' ', 'RECORDINDEX', '', 0, null, null, 242) !!
EXECUTE PROCEDURE ImportDocCLS(300500, 3005, '', 'TENDERCAPTION', ' ', 'ID', ' ', '', '', 0, null, null, 240) !!

DROP PROCEDURE ImportDocCLS
!!

COMMIT WORK!!

CREATE PROCEDURE ImportField (
   ID_                INTEGER,
   NAME_              VARCHAR(255),
   ITFFIELDNAME_      VARCHAR(255),
   NOTE_              VARCHAR(255),
   TEMPLATEFIELD_     VARCHAR(255),
   ISBUDGET_          INTEGER,
   DOCTYPEREF_        INTEGER,
   DETAILNUMBER_      INTEGER,
   ONLYREAD_          INTEGER,
   ReportFieldName_   VARCHAR(255),
   KIND_          INTEGER,
   FIELDINFOREF_      INTEGER,
   CONTAINERREF_      INTEGER,
   ATTRFIELDKIND_     INTEGER                    
) AS
DECLARE VARIABLE IDExists INTEGER;
DECLARE VARIABLE FieldID  INTEGER;
BEGIN
   SELECT COUNT (ID)
     FROM DocumentFields
    WHERE (ID = :ID_)
     INTO :IDExists;

   IF (:IDExists <> 0) THEN
      UPDATE DocumentFields
         SET NAME = :NAME_,
             ITFFIELDNAME = :ITFFIELDNAME_,
             NOTE = :NOTE_,
             TEMPLATEFIELD = :TEMPLATEFIELD_,
             ISBUDGET = :ISBUDGET_,
             DOCTYPEREF = :DOCTYPEREF_,
             DETAILNUMBER = :DETAILNUMBER_,
             ONLYREAD = :ONLYREAD_,
             ReportFieldName = :ReportFieldName_,
             FIELDINFOREF = :FIELDINFOREF_,
             CONTAINERREF = :CONTAINERREF_,
             ATTRFIELDKIND = :ATTRFIELDKIND_
       WHERE (ID = :ID_)
         AND NOT (
                      (
                          (
                           (NAME IS NOT NULL AND :NAME_ IS NOT NULL) AND
                           (UPPER (NAME) = UPPER (:NAME_))
                          )
                       OR (NAME IS NULL AND :NAME_ IS NULL)
                      )

                  AND (
                          (
                           (ITFFIELDNAME IS NOT NULL AND :ITFFIELDNAME_ IS NOT NULL) AND
                           (UPPER (ITFFIELDNAME) = UPPER (:ITFFIELDNAME_))
                          )
                       OR (ITFFIELDNAME IS NULL AND :ITFFIELDNAME_ IS NULL)
                      )

                  AND (
                          (
                           (NOTE IS NOT NULL AND :NOTE_ IS NOT NULL) AND
                           (UPPER (NOTE) = UPPER (:NOTE_))
                          )
                       OR (NOTE IS NULL AND :NOTE_ IS NULL)
                      )
                  AND (UPPER (TEMPLATEFIELD) = UPPER (:TEMPLATEFIELD_))
                  AND (
                          (
                           (ISBUDGET IS NOT NULL AND :ISBUDGET_ IS NOT NULL) AND
                           (ISBUDGET = :ISBUDGET_)
                          )
                       OR (ISBUDGET IS NULL AND :ISBUDGET_ IS NULL)
                      )
                  AND (
                          (
                           (FIELDINFOREF IS NOT NULL AND :FIELDINFOREF_ IS NOT NULL) AND
                           (FIELDINFOREF = :FIELDINFOREF_)
                          )
                       OR (FIELDINFOREF IS NULL AND :FIELDINFOREF_ IS NULL)
                      )
                  AND (
                          (
                           (CONTAINERREF IS NOT NULL AND :CONTAINERREF_ IS NOT NULL) AND
                           (CONTAINERREF = :CONTAINERREF_)
                          )
                       OR (CONTAINERREF IS NULL AND :CONTAINERREF_ IS NULL)
                      )   
                  AND (
                          (
                           (ATTRFIELDKIND IS NOT NULL AND :ATTRFIELDKIND_ IS NOT NULL) AND
                           (ATTRFIELDKIND = :ATTRFIELDKIND_)
                          )
                       OR (ATTRFIELDKIND IS NULL AND :ATTRFIELDKIND_ IS NULL)
                      )                         
                  AND (DOCTYPEREF = :DOCTYPEREF_)
                  AND (DETAILNUMBER = :DETAILNUMBER_)
                  AND (ONLYREAD = :ONLYREAD_)
                  AND (
                          (
                           (ReportFieldName IS NOT NULL AND :ReportFieldName_ IS NOT NULL) AND
                           (UPPER (ReportFieldName) = UPPER (:ReportFieldName_))
                          )
                       OR (ReportFieldName IS NULL AND :ReportFieldName_ IS NULL)
                      )
                 );
   ELSE
      INSERT INTO DocumentFields
                  (ID, NAME, ITFFIELDNAME, NOTE, TEMPLATEFIELD,
                   ISBUDGET, DOCTYPEREF, DETAILNUMBER, ONLYREAD,ReportFieldName, FIELDINFOREF, ContainerRef, AttrFieldKind
                  )
           VALUES (:ID_, :NAME_, :ITFFIELDNAME_, :NOTE_, :TEMPLATEFIELD_,
                   :ISBUDGET_, :DOCTYPEREF_, :DETAILNUMBER_, :ONLYREAD_, :ReportFieldName_, :FIELDINFOREF_, :ContainerRef_, :AttrFieldKind_
                  );

   FOR SELECT ID
            FROM DocumentFields
           WHERE (ID <> :ID_)
             AND (DOCTYPEREF = :DOCTYPEREF_)
             AND (
                     (
                      (ISBUDGET IS NOT NULL AND :ISBUDGET_ IS NOT NULL) AND
                      (ISBUDGET = :ISBUDGET_)
                     )
                  OR (ISBUDGET IS NULL AND :ISBUDGET_ IS NULL)
                 )
             AND (DETAILNUMBER = :DETAILNUMBER_)
             AND ( /*     ,      ,       */
                    (
                      ((:ITFFIELDNAME_ IS NULL)or(:ITFFIELDNAME_=' ')or (:ITFFIELDNAME_=''))
                      and not((:TEMPLATEFIELD_ IS NULL)or(:TEMPLATEFIELD_='')or(:TEMPLATEFIELD_=' '))
                      and(TEMPLATEFIELD is not null) and (UPPER(TEMPLATEFIELD)=UPPER(:TEMPLATEFIELD_))
                    )
                 or (
                       not ((:ITFFIELDNAME_ IS NULL) or (:ITFFIELDNAME_=' ') or (:ITFFIELDNAME_=''))
                       and (ITFFIELDNAME IS not NULL) and (UPPER(ITFFIELDNAME)=UPPER(:ITFFIELDNAME_))
                    )
                 )
            INTO :FieldID
   DO BEGIN
      UPDATE State_OpenFields
         SET DOCFIELDREF = :ID_
       WHERE (DOCFIELDREF = :FieldID);

      UPDATE DOCLOCKFIELDS
         SET FIELDREF = :ID_
       WHERE (FIELDREF = :FieldID);

      UPDATE staticlinks
         SET PARENTFIELDREF = :ID_
      WHERE (PARENTFIELDREF = :FieldID);

      UPDATE staticlinks
         SET CHILDFIELDREF = :ID_
      WHERE (CHILDFIELDREF = :FieldID);

      DELETE FROM DocumentFields
            WHERE (ID = :FieldID);
   END
END
!!

CREATE PROCEDURE DeleteFields (ID_ INTEGER) AS
BEGIN
  DELETE FROM State_OpenFields
  WHERE (docfieldref = :ID_);
  DELETE FROM DOCLOCKFIELDS
  WHERE (fieldref = :ID_);

  DELETE FROM STATE_JUMPCONTROL
  WHERE STATICLINKREF IN(SELECT ID FROM staticlinks
                           WHERE (PARENTFIELDREF=:ID_)OR(CHILDFIELDREF=:ID_));
  DELETE FROM staticlinks
  WHERE (PARENTFIELDREF=:ID_)OR(CHILDFIELDREF=:ID_);

  DELETE FROM DOCUMENTTEMPLATEFIELDS
  WHERE (FIELDS=:ID_);

  DELETE FROM DocumentFields
  WHERE (id = :ID_);
END
!!

CREATE PROCEDURE INSERTCONST (
  PROGINDEX_     INTEGER,
  CONSTINDEX_    INTEGER,
  CONSTTYPE_     INTEGER,
  NOTE_          VARCHAR(255),
  VARCHARVALUE_  VARCHAR(255),
  DOUBLEVALUE_   Double precision,
  INTVALUE_      INTEGER,
  EditDocCode_   INTEGER
) AS
DECLARE VARIABLE IDEXISTS INTEGER;
BEGIN
  IF (:CONSTTYPE_ = 3) THEN
  BEGIN
    SELECT COUNT (PROGINDEX)
    FROM IntConst
    WHERE (PROGINDEX = :PROGINDEX_) AND (CONSTINDEX = :CONSTINDEX_)
    INTO IDExists;

    IF (:IDExists = 0) THEN
      INSERT INTO INTCONST
        (PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,EDITDOCCODE)
      VALUES
        (:PROGINDEX_,:CONSTINDEX_,:INTVALUE_,:NOTE_,:EDITDOCCODE_);
    ELSE 
      UPDATE INTCONST SET
        NOTE = :NOTE_,
        EDITDOCCODE = :EDITDOCCODE_
      WHERE (PROGINDEX=:PROGINDEX_) AND (CONSTINDEX=:CONSTINDEX_);
  END

  IF (:CONSTTYPE_ = 8) THEN
  BEGIN
    SELECT COUNT (PROGINDEX)
    FROM VarcharConst
    WHERE (PROGINDEX = :PROGINDEX_) AND (CONSTINDEX = :CONSTINDEX_)
    INTO IDExists;

    IF (:IDExists = 0) THEN
      INSERT INTO VARCHARCONST
        (PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,EDITDOCCODE)
      VALUES
        (:PROGINDEX_,:CONSTINDEX_,:VARCHARVALUE_,:NOTE_,:EDITDOCCODE_);
    ELSE 
      UPDATE VARCHARCONST SET
        NOTE = :NOTE_,
        EDITDOCCODE = :EDITDOCCODE_
      WHERE (PROGINDEX=:PROGINDEX_) AND (CONSTINDEX=:CONSTINDEX_);
  END

  IF (:CONSTTYPE_ = 5) THEN
  BEGIN
    SELECT COUNT (PROGINDEX)
    FROM RealConst
    WHERE (PROGINDEX = :PROGINDEX_) AND (CONSTINDEX = :CONSTINDEX_)
    INTO IDExists;

    IF (:IDExists = 0) THEN
      INSERT INTO REALCONST
        (PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,EDITDOCCODE)
      VALUES
        (:PROGINDEX_,:CONSTINDEX_,:DOUBLEVALUE_,:NOTE_,:EDITDOCCODE_);
    ELSE 
      UPDATE REALCONST SET
        NOTE = :NOTE_,
        EDITDOCCODE = :EDITDOCCODE_
      WHERE (PROGINDEX=:PROGINDEX_) AND (CONSTINDEX=:CONSTINDEX_);
  END
END
!!

CREATE PROCEDURE DELETECONST (
  PROGINDEX_     INTEGER,
  CONSTINDEX_    INTEGER,
  CONSTTYPE_     INTEGER
) AS
DECLARE VARIABLE IDEXISTS INTEGER;
BEGIN
  IF (:CONSTTYPE_ = 3) THEN
  BEGIN
    UPDATE IntConst
      SET CloseDate = 'NOW'
    WHERE (PROGINDEX = :PROGINDEX_) AND (CONSTINDEX = :CONSTINDEX_);
  END

  IF (:CONSTTYPE_ = 8) THEN
  BEGIN
    UPDATE VARCHARCONST
      SET CloseDate = 'NOW'
    WHERE (PROGINDEX = :PROGINDEX_) AND (CONSTINDEX = :CONSTINDEX_);
  END

  IF (:CONSTTYPE_ = 5) THEN
  BEGIN
    UPDATE REALCONST
      SET CloseDate = 'NOW'
    WHERE (PROGINDEX = :PROGINDEX_) AND (CONSTINDEX = :CONSTINDEX_);
  END
END
!!

/*        */
ALTER TRIGGER TR_INTCONST_BU_500 INACTIVE
!!
ALTER TRIGGER TR_VARCHARCONST_BU_500 INACTIVE
!!
ALTER TRIGGER TR_REALCONST_BU_500 INACTIVE
!!

/*      */
/*   (), (1) */
EXECUTE PROCEDURE ImportField(90611088, '', 'KESR', '', 'KESR', 1, 906, 1, 0, '', 0, 17712, 0, 0) !!
/*  , +(2) */
EXECUTE PROCEDURE ImportField(250410100, '   ()', 'AutoSanction', '', 'AutoSanction', 2, 2504, 0, 0, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(250410101, '  ', 'PurchaseCode', '  ', 'PurchaseCode', 2, 2504, 0, 0, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(250410102, '  ', 'AutoSanctionCode', '', ' ', 2, 2504, 0, 0, '', 0, null, 0, 0) !!
/*    , +(2) */
EXECUTE PROCEDURE ImportField(300110033, '  ', 'PurchaseCode', '  ', 'PurchaseCode', 2, 3001, 0, 0, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(300110034, ' ', 'AVersion', '', 'AVersion', 2, 3001, 0, 0, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(300110035, '  /', 'ParentRef', '', 'PArentRef', 2, 3001, 0, 0, '', 0, null, 0, 0) !!
/* -, +(2) */
EXECUTE PROCEDURE ImportField(300510001, '', 'BudgetRef', '', 'BudgetRef', 2, 3005, 0, 1, '', 0, 21277, 0, 0) !!
EXECUTE PROCEDURE ImportField(300510002, ' ', 'RejectCls', '', 'RejectCls', 2, 3005, 0, 0, '', 0, 21288, 0, 0) !!
EXECUTE PROCEDURE ImportField(300510003, '  ()', 'RejectCause', '', 'RejectCause', 2, 3005, 0, 0, '', 0, 21289, 0, 0) !!
EXECUTE PROCEDURE ImportField(300510004, '', 'Org_Name', '', 'Org_Name', 2, 3005, 0, 1, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(300510005, '', 'Note', '', 'Note', 2, 3005, 0, 0, '', 0, 21310, 0, 0) !!
EXECUTE PROCEDURE ImportField(300510006, ' -  (+)', 'FacialAccClsCol', '', 'FacialAccClsCol', 2, 3005, 0, 1, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(300510007, ' ', 'FacialAccCls', '', 'FacialAccCls', 2, 3005, 0, 0, '', 0, 21279, 0, 0) !!
EXECUTE PROCEDURE ImportField(300510008, '   ', 'DocNumber', '   ', 'DocNumber', 2, 3005, 0, 0, '', 0, 21278, 0, 0) !!
EXECUTE PROCEDURE ImportField(300510009, ' ', 'AYear', '', 'AYear', 2, 3005, 0, 0, '', 0, 21284, 0, 0) !!
EXECUTE PROCEDURE ImportField(300510010, '', 'AcceptSumma', '', 'AcceptSumma', 2, 3005, 0, 0, '', 0, 21286, 0, 0) !!
EXECUTE PROCEDURE ImportField(300510011, '  ', 'AcceptDate', '', 'AcceptDate', 2, 3005, 0, 0, '', 0, 21282, 0, 0) !!
EXECUTE PROCEDURE ImportField(300510012, '   ', 'ReworkCause', '', 'ReworkCause', 2, 3005, 0, 0, '', 0, 25041, 0, 0) !!
EXECUTE PROCEDURE ImportField(300510013, '/  ( - )', 'FacialCode', '', ' ', 2, 3005, 0, 0, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(300510014, ' - ', 'OrgRecipient', '', ' ', 2, 3005, 0, 0, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(300510015, ' ', 'LastAdjustment', '', 'LastAdjustment', 2, 3005, 0, 1, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(300510016, ' ', 'AVersion', '', 'AVersion', 2, 3005, 0, 0, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(300510017, '', 'RealID', '', 'RealID', 2, 3005, 0, 0, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(300510018, 'ID', 'ID', '', 'ID', 2, 3005, 0, 1, '', 0, null, 0, 0) !!
/*  -, +(2) */
EXECUTE PROCEDURE ImportField(300610049, '  ', 'PurchaseCode', '  ', 'PurchaseCode', 2, 3006, 0, 0, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(300610050, ' ', 'AVersion', '', 'AVersion', 2, 3006, 0, 0, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(300610051, '  /', 'ParentRef', '', 'ParentRef', 2, 3006, 0, 0, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(300610052, ' ', 'PlanCaption', '', 'PlanCaption', 2, 3006, 0, 0, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(300611005, '2', 'OKPD2', '', 'OKPD2', 2, 3006, 1, 0, '', 0, 37808, 0, 0) !!
/*  , +(2) */
EXECUTE PROCEDURE ImportField(301010001, '', 'BudgetRef', '', 'BudgetRef', 2, 3010, 0, 1, '', 0, 21277, 0, 0) !!
EXECUTE PROCEDURE ImportField(301010007, ' ', 'RejectCls', '', 'RejectCls', 2, 3010, 0, 0, '', 0, 21288, 0, 0) !!
EXECUTE PROCEDURE ImportField(301010008, '  ()', 'RejectCause', '', 'RejectCause', 2, 3010, 0, 0, '', 0, 21289, 0, 0) !!
EXECUTE PROCEDURE ImportField(301010011, '', 'Org_Name', '', 'Org_Name', 2, 3010, 0, 1, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(301010012, '', 'Note', '', 'Note', 2, 3010, 0, 0, '', 0, 21310, 0, 0) !!
EXECUTE PROCEDURE ImportField(301010013, ' -  (+)', 'FacialAccClsCol', '', 'FacialAccClsCol', 2, 3010, 0, 1, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(301010014, ' ', 'FacialAccCls', '', 'FacialAccCls', 2, 3010, 0, 0, '', 0, 21279, 0, 0) !!
EXECUTE PROCEDURE ImportField(301010016, '   ', 'DocNumber', '   ', 'DocNumber', 2, 3010, 0, 0, '', 0, 21278, 0, 0) !!
EXECUTE PROCEDURE ImportField(301010017, ' ', 'AYear', '', 'AYear', 2, 3010, 0, 0, '', 0, 21284, 0, 0) !!
EXECUTE PROCEDURE ImportField(301010018, '', 'AcceptSumma', '', 'AcceptSumma', 2, 3010, 0, 0, '', 0, 21286, 0, 0) !!
EXECUTE PROCEDURE ImportField(301010019, '  ', 'AcceptDate', '', 'AcceptDate', 2, 3010, 0, 0, '', 0, 21282, 0, 0) !!
EXECUTE PROCEDURE ImportField(301010020, '   ', 'ReworkCause', '', 'ReworkCause', 2, 3010, 0, 0, '', 0, 25041, 0, 0) !!
EXECUTE PROCEDURE ImportField(301010022, '/  ( - )', 'FacialCode', '', ' ', 2, 3010, 0, 0, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(301010023, ' - ', 'OrgRecipient', '', ' ', 2, 3010, 0, 0, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(301010024, ' ', 'LastAdjustment', '', 'LastAdjustment', 2, 3010, 0, 1, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(301010028, ' ', 'AVersion', '', 'AVersion', 2, 3010, 0, 0, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(301010030, '', 'RealID', '', 'RealID', 2, 3010, 0, 0, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(301010031, 'ID', 'ID', '', 'ID', 2, 3010, 0, 1, '', 0, null, 0, 0) !!
/*   , +(2) */
EXECUTE PROCEDURE ImportField(301110001, '', 'BudgetRef', '', 'BudgetRef', 2, 3011, 0, 1, '', 0, 21277, 0, 0) !!
EXECUTE PROCEDURE ImportField(301110002, '-  ', 'YearAcceptSumma', '', 'YearAcceptSumma', 2, 3011, 0, 0, '', 0, 21307, 0, 0) !!
EXECUTE PROCEDURE ImportField(301110003, '  ', 'TenderTarget', '', 'TenderTarget', 2, 3011, 0, 0, '', 0, 21309, 0, 0) !!
EXECUTE PROCEDURE ImportField(301110007, ' ', 'RejectCls', '', 'RejectCls', 2, 3011, 0, 0, '', 0, 21288, 0, 0) !!
EXECUTE PROCEDURE ImportField(301110008, '  ()', 'RejectCause', '', 'RejectCause', 2, 3011, 0, 0, '', 0, 21289, 0, 0) !!
EXECUTE PROCEDURE ImportField(301110009, '     ', 'PeriodYear', '', 'PeriodYear', 2, 3011, 0, 0, '', 0, 21319, 0, 0) !!
EXECUTE PROCEDURE ImportField(301110010, '   ', 'PeriodVariant', '', 'PeriodVariant', 2, 3011, 0, 0, '', 0, 21283, 0, 0) !!
EXECUTE PROCEDURE ImportField(301110011, '', 'Org_Name', '', 'Org_Name', 2, 3011, 0, 1, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(301110012, '', 'Note', '', 'Note', 2, 3011, 0, 0, '', 0, 21310, 0, 0) !!
EXECUTE PROCEDURE ImportField(301110013, ' -  (+)', 'FacialAccClsCol', '', 'FacialAccClsCol', 2, 3011, 0, 1, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(301110014, ' ', 'FacialAccCls', '', 'FacialAccCls', 2, 3011, 0, 0, '', 0, 21279, 0, 0) !!
EXECUTE PROCEDURE ImportField(301110017, ' ', 'AYear', '', 'AYear', 2, 3011, 0, 0, '', 0, 21284, 0, 0) !!
EXECUTE PROCEDURE ImportField(301110018, '', 'AcceptSumma', '', 'AcceptSumma', 2, 3011, 0, 0, '', 0, 21286, 0, 0) !!
EXECUTE PROCEDURE ImportField(301110019, '  ', 'AcceptDate', '', 'AcceptDate', 2, 3011, 0, 0, '', 0, 21282, 0, 0) !!
EXECUTE PROCEDURE ImportField(301110020, ' ', 'ReworkCause', '', 'ReworkCause', 2, 3011, 0, 0, '', 0, 25041, 0, 0) !!
EXECUTE PROCEDURE ImportField(301110022, '/  ( - )', 'FacialCode', '', ' ', 2, 3011, 0, 0, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(301110023, ' - ', 'OrgRecipient', '', ' ', 2, 3011, 0, 0, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(301110024, ' ', 'LastAdjustment', '', 'LastAdjustment', 2, 3011, 0, 1, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(301110025, '   ', 'PeriodOther', '', 'PeriodOther', 2, 3011, 0, 0, '', 0, 21283, 0, 0) !!
EXECUTE PROCEDURE ImportField(301110026, '  ', 'PurchaseCode', '  ', 'PurchaseCode', 2, 3011, 0, 0, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(301110028, ' ', 'AVersion', '', 'AVersion', 2, 3011, 0, 0, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(301110029, '  /', 'ParentRef', '', 'ParentRef', 2, 3011, 0, 0, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(301110049, ' ', 'PlanCaption', '', 'PlanCaption', 2, 3011, 0, 0, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(301110050, ' ', 'PurchaseType', '', 'PurchaseType', 2, 3011, 0, 0, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111001, '', 'Note', '', 'Note', 2, 3011, 1, 0, '', 0, 21054, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111002, '', 'KESR', '', 'KESR', 2, 3011, 1, 0, '', 0, 21038, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111003, '', 'KCSR', '', 'KCSRKey', 2, 3011, 1, 1, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111004, '', 'FactCLSCode', '', 'FactCLS', 2, 3011, 1, 0, '', 0, 36863, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111005, ' -  (+)', 'FacialAccClsCol', '', 'FacialAccClsCol', 2, 3011, 1, 1, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111006, ' ', 'FacialAccCls', '', 'FacialAccCls', 2, 3011, 1, 0, '', 0, 21033, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111007, '  ', 'AcceptSumma', '', 'AcceptSumma', 2, 3011, 1, 0, '', 0, 21090, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111008, 'IV ', 'AcceptQuarter4', '', 'AcceptQuarter4', 2, 3011, 1, 0, '', 0, 21088, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111009, 'III ', 'AcceptQuarter3', '', 'AcceptQuarter3', 2, 3011, 1, 0, '', 0, 21086, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111010, 'II ', 'AcceptQuarter2', '', 'AcceptQuarter2', 2, 3011, 1, 0, '', 0, 21084, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111011, 'I ', 'AcceptQuarter1', '', 'AcceptQuarter1', 2, 3011, 1, 0, '', 0, 21082, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111012, '', 'AcceptMonth12', '', 'AcceptMonth12', 2, 3011, 1, 0, '', 0, 21080, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111013, '', 'AcceptMonth11', '', 'AcceptMonth11', 2, 3011, 1, 0, '', 0, 21078, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111014, '', 'AcceptMonth10', '', 'AcceptMonth10', 2, 3011, 1, 0, '', 0, 21076, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111015, '', 'AcceptMonth09', '', 'AcceptMonth09', 2, 3011, 1, 0, '', 0, 21074, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111016, '', 'AcceptMonth08', '', 'AcceptMonth08', 2, 3011, 1, 0, '', 0, 21072, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111017, '', 'AcceptMonth07', '', 'AcceptMonth07', 2, 3011, 1, 0, '', 0, 21070, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111018, '', 'AcceptMonth06', '', 'AcceptMonth06', 2, 3011, 1, 0, '', 0, 21068, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111019, '', 'AcceptMonth05', '', 'AcceptMonth05', 2, 3011, 1, 0, '', 0, 21066, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111020, '', 'AcceptMonth04', '', 'AcceptMonth04', 2, 3011, 1, 0, '', 0, 21064, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111021, '', 'AcceptMonth03', '', 'AcceptMonth03', 2, 3011, 1, 0, '', 0, 21062, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111022, '', 'AcceptMonth02', '', 'AcceptMonth02', 2, 3011, 1, 0, '', 0, 21060, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111023, '', 'AcceptMonth01', '', 'AcceptMonth01', 2, 3011, 1, 0, '', 0, 21058, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111024, '  (+)', 'TreeOwner0', ' ', 'TreeOwner0', 2, 3011, 1, 0, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111025, '', 'KVSR', '', 'KVSR', 2, 3011, 1, 1, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111026, '', 'KFSR', '', 'KFSR', 2, 3011, 1, 0, '', 0, 21034, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111027, '', 'KVR', '', 'KVR', 2, 3011, 1, 1, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111028, 'MEANSTYPECls', 'MEANSTYPECls', 'MEANSTYPECls', 'MEANSTYPECls', 2, 3011, 1, 0, '', 0, 21042, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111029, '', 'KCSRCode', '', 'KCSR', 2, 3011, 1, 0, '', 0, 25462, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111030, '', 'KVSRCode', '', 'KVSR', 2, 3011, 1, 0, '', 0, 25472, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111031, '', 'KVRCode', '', 'KVR', 2, 3011, 1, 0, '', 0, 25467, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111032, '  ', 'SummaYear2', '', 'SummaYear2', 2, 3011, 1, 0, '', 0, 26652, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111033, '  ', 'SummaYear3', '', 'SummaYear3', 2, 3011, 1, 0, '', 0, 26653, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111034, '', 'DirectionClsCode', '', ' ', 2, 3011, 1, 0, '', 0, 36861, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111035, '/  ( - )', 'FacialCode', '', ' ', 2, 3011, 1, 0, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111036, '( - )', 'FacialOrgName', '', ' ', 2, 3011, 1, 1, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111037, ' . ', 'FinTypeCode', '', ' ', 2, 3011, 1, 0, '', 0, 36853, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111038, ' ', 'subkesr', '', ' ', 2, 3011, 1, 0, '', 0, 21039, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111039, ' ', 'SubsidyClsCode', '', ' ', 2, 3011, 1, 0, '', 0, 26641, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111040, ' ', 'FinSourceCls', '', 'FinSourceCls', 2, 3011, 1, 0, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111041, ' .  ()', 'FinType', '', ' ', 2, 3011, 1, 1, '', 0, 21114, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111042, ' ()', 'DirectionCls', '', ' ', 2, 3011, 1, 1, '', 0, 21104, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111043, '', 'InvestObject', '', ' ', 2, 3011, 1, 0, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111044, '', 'InvestObjectCode', '', ' ', 2, 3011, 1, 0, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111045, ' ()', 'FactCls', '', 'FactClsKey', 2, 3011, 1, 0, '', 0, 21040, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111046, '  ', 'TransfertClsCode', '  ', 'TransfertClsCode', 2, 3011, 1, 0, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111047, '  ', 'BudAllocationClsCode', '', 'BudAllocationClsCode', 2, 3011, 1, 0, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE ImportField(301111048, '  ', 'PayPromiseClsCode', '', 'PayPromiseClsCode', 2, 3011, 1, 0, '', 0, null, 0, 0) !!
/*  , (1) */
EXECUTE PROCEDURE ImportField(991610211, ' \ , , \     ', '__', '', ' ', 1, 9916, 0, 0, '', 0, null, 0, 0) !!
EXECUTE PROCEDURE InsertConst(32, 46, 3, ' \ , , \     ', '', 0, 0, 9916) !!

/*        */
ALTER TRIGGER TR_INTCONST_BU_500 ACTIVE
!!
ALTER TRIGGER TR_VARCHARCONST_BU_500 ACTIVE
!!
ALTER TRIGGER TR_REALCONST_BU_500 ACTIVE
!!

DROP PROCEDURE ImportField !!
DROP PROCEDURE DeleteFields !!
DROP PROCEDURE InsertConst !!
DROP PROCEDURE DELETECONST !!


CREATE PROCEDURE DOCLOCK_IMPORT(
  NAME            VARCHAR(50),
  LOCKMASK        INTEGER,
  DOCREF          INTEGER,
  DETAILNUM       INTEGER,
  RUNPOS          INTEGER,
  LOCKACTION      INTEGER,
  USERIGHTS       INTEGER,
  FORMULA         VARCHAR(1024),
  FORDELETE       INTEGER,
  ISSYSTEM        INTEGER,
  NOTE            VARCHAR(512),
  FORINSERT       INTEGER,
  ValidateMessage VARCHAR(255),
  Validatelevel   INTEGER,
  ValidateFilter  VARCHAR(1024),
  ISBUDGET        INTEGER) as
DECLARE VARIABLE DOCLOCKID INTEGER;
BEGIN
   DOCLOCKID=0;
   SELECT ID
   FROM DOCLOCK
   WHERE (DOCREF = :DOCREF) AND (DETAILNUM = :DETAILNUM) AND (NAME = :NAME) AND (ISBUDGET = :ISBUDGET)
   INTO :DOCLOCKID;

   IF ((:DOCLOCKID<>0)and(:DOCLOCKID is not null)) THEN
     IF (ISSYSTEM = 3) THEN
       UPDATE DOCLOCK SET
         NAME = :NAME,
         LOCKMASK = :LOCKMASK,
         DOCREF = :DOCREF,
         DETAILNUM = :DETAILNUM,
         RUNPOS = :RUNPOS,
         LOCKACTION = :LOCKACTION,
         FORMULA = :FORMULA,
         FORDELETE = :FORDELETE,
         ISSYSTEM = :ISSYSTEM,
         NOTE = :NOTE,
         FORINSERT = :FORINSERT,
         VALIDATEMESSAGE = :VALIDATEMESSAGE,
         VALIDATELEVEL = :VALIDATELEVEL,
         VALIDATEFILTER = :VALIDATEFILTER,
         ISBUDGET = :ISBUDGET,
         USERIGHTS = :USERIGHTS
       WHERE ID = :DOCLOCKID;  
     ELSE
       UPDATE DOCLOCK SET
         NAME = :NAME,
         LOCKMASK = :LOCKMASK,
         DOCREF = :DOCREF,
         DETAILNUM = :DETAILNUM,
         RUNPOS = :RUNPOS,
         LOCKACTION = :LOCKACTION,
         FORMULA = :FORMULA,
         FORDELETE = :FORDELETE,
         ISSYSTEM = :ISSYSTEM,
         NOTE = :NOTE,
         FORINSERT = :FORINSERT,
         VALIDATEMESSAGE = :VALIDATEMESSAGE,
         VALIDATELEVEL = :VALIDATELEVEL,
         VALIDATEFILTER = :VALIDATEFILTER,
         ISBUDGET = :ISBUDGET
       WHERE ID = :DOCLOCKID;    
   ELSE 
     INSERT INTO DOCLOCK
         (ISBUDGET,NAME,LOCKMASK,DOCREF,DETAILNUM,RUNPOS,LOCKACTION,USERIGHTS,FORMULA,FORDELETE,ISSYSTEM,NOTE,FORINSERT,VALIDATEMESSAGE,VALIDATELEVEL,VALIDATEFILTER)
      VALUES
         (:ISBUDGET,:NAME,:LOCKMASK,:DOCREF,:DETAILNUM,:RUNPOS,:LOCKACTION,:USERIGHTS,:FORMULA,:FORDELETE,:ISSYSTEM,:NOTE,:FORINSERT,:VALIDATEMESSAGE,:VALIDATELEVEL,:VALIDATEFILTER);
END
!!

CREATE PROCEDURE DOCLOCK_DELETE(NAME VARCHAR(50), DOCREF INTEGER, DETAILNUM INTEGER, ISBUDGET INTEGER) AS
DECLARE VARIABLE DOCLOCKID INTEGER;
BEGIN
    DOCLOCKID=0;
    SELECT ID
    FROM DOCLOCK
    WHERE (DOCREF = :DOCREF) AND (DETAILNUM = :DETAILNUM) AND (NAME = :NAME) AND (ISBUDGET = :ISBUDGET)
    INTO :DOCLOCKID; 
    
    IF ((:DOCLOCKID <> 0)and(:DOCLOCKID is not null)) THEN
    BEGIN
        DELETE FROM DOCLOCK
        WHERE ID = :DOCLOCKID;
    END           
END
!!

CREATE PROCEDURE DOCLOCKFIELDS_DELETE(NAME VARCHAR(50), DOCREF INTEGER, DETAILNUM INTEGER, CANCHANGEFIELDS INTEGER, ISBUDGET INTEGER) AS
DECLARE VARIABLE DOCLOCKID INTEGER;
BEGIN
   DOCLOCKID=0;
   SELECT ID
   FROM DOCLOCK
   WHERE (DOCREF = :DOCREF) AND (DETAILNUM = :DETAILNUM) AND (NAME = :NAME) AND (ISBUDGET = :ISBUDGET)
   INTO :DOCLOCKID;
   
   IF ((:DOCLOCKID <> 0)and(:DOCLOCKID is not null)) THEN
   BEGIN
      DELETE FROM DOCLOCKFIELDS
      WHERE (DOCLOCKREF = :DOCLOCKID) AND ((ISSYSTEM = 1) OR ((ISSYSTEM = 0) AND (:CANCHANGEFIELDS = 0) ));
   END
END
!!

/*      DocLockFields*/
CREATE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(NAME VARCHAR(50), DOCREF INTEGER, DETAILNUM INTEGER, FIELDREF INTEGER, ISBUDGET INTEGER) AS
DECLARE VARIABLE NID INTEGER;
DECLARE VARIABLE DOCLOCKFIELDID INTEGER;
BEGIN
  NID = 0;
  SELECT ID FROM DOCLOCK
  WHERE (DOCREF = :DOCREF) AND (DETAILNUM = :DETAILNUM) AND (NAME = :NAME) AND (ISBUDGET = :ISBUDGET)
  INTO :NID;
     
  IF ((:NID <> 0)and(:NID is not null)) THEN
  BEGIN
    DOCLOCKFIELDID = 0;
    SELECT ID FROM DOCLOCKFIELDS
    WHERE (DOCLOCKREF = :NID) AND (FIELDREF = :FIELDREF)
    INTO :DOCLOCKFIELDID;
    IF (:DOCLOCKFIELDID = 0) THEN
      INSERT INTO DOCLOCKFIELDS
        (DOCLOCKREF,FIELDREF,ISSYSTEM)
      VALUES
        (:NID,:FIELDREF,1);
    ELSE
      UPDATE DOCLOCKFIELDS SET
        ISSYSTEM = 1
      WHERE ID = :DOCLOCKFIELDID;      
  END
END
!!

/*  */
EXECUTE PROCEDURE DOCLOCK_DELETE('   ',2504, 0, 1) !!
EXECUTE PROCEDURE DOCLOCK_DELETE(' ',3011, 0, 1) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('   ',0,200,1,0,11,0,'',0,1,'    ,      - \.',0,'        ',null,'(([960110035] between 010800 and 011099)
([960110021]=("_.",.[20011008])))',1) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('   ', 200, 1, 0, 1) !!
/*  " " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('   ',200,1,20011028,1) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('   ',0,323,1,0,11,0,'',0,1,'    ,      - \.',0,'        ',null,'(([960110035] between 010800 and 011099)
([960110021]=("_.",.[32311012])))',1) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('   ', 323, 1, 0, 1) !!
/*  " ()" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('   ',323,1,32311163,1) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('   ',0,324,1,0,11,0,'',0,1,'    ,      - \.',0,'        ',null,'(([960110035] between 010800 and 011099)
([960110021]=("_.",.[32411026])))',1) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('   ', 324, 1, 0, 1) !!
/*  " ()" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('   ',324,1,32411204,1) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('      ',0,906,1,0,11,0,'',0,1,'       ',0,'      ',null,'[986810007] = 1',1) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('      ', 906, 1, 0, 1) !!
/*  "" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('      ',906,1,90611088,1) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('   36  ',0,2504,0,0,9,0,'[250410101] like "____________________________________"  [250410101] = ""',0,3,'     36   ( ,  )',0,'     36   ( ,  )',0,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('   36  ', 2504, 0, 0, 2) !!
/*  "  " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('   36  ',2504,0,250410101,2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('   ',0,2504,0,0,11,0,'',0,3,'     ',0,'           ',null,'([993010022] = )  ([993010020] = [993010020])  ([993010017] = 1)',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('   ', 2504, 0, 0, 2) !!
/*  "   ()" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('   ',2504,0,250410100,2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('   36  ',0,3001,0,0,9,0,'[300110033] like "____________________________________"  [300110033] = ""',0,3,'     36   ( ,  )',0,'     36   ( ,  )',0,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('   36  ', 3001, 0, 0, 2) !!
/*  "  " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('   36  ',3001,0,300110033,2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT(' ,   ',65540,3005,-1,0,4,1,'',0,2,'     ,   .       . ,     .',0,'',null,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE(' ,   ', 3005, -1, 1, 2) !!
/*  "" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',3005,-1,300510005,2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT(' ',65540,3005,-1,0,4,1,'',0,1,'  .       .',0,'',null,'',1) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE(' ', 3005, -1, 0, 1) !!
/*  "  " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',3005,-1,300510011,1) !!
/*  "  ()" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',3005,-1,300510003,1) !!
/*  " " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',3005,-1,300510002,1) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('  ',64,3005,-1,0,8,1,'',1,1,'         .       .',1,'',null,'',1) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('  ', 3005, -1, 0, 1) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT(' ',65540,3005,-1,0,4,1,'',0,3,'',0,'',null,'',1) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE(' ', 3005, -1, 0, 1) !!
/*  "  " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',3005,-1,300510011,1) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('  ',2,3005,-1,0,8,1,'',1,1,'     ,   .       .',2,'',null,'',1) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('  ', 3005, -1, 0, 1) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('  ',65536,3005,-1,0,7,0,'',1,3,'   .   ,   .           .',2,'',null,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('  ', 3005, -1, 0, 2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT(' ',65536,3005,-1,0,6,0,'',1,1,'  .       .',2,'',null,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE(' ', 3005, -1, 0, 2) !!
/*  "  " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',3005,-1,300510011,2) !!
/*  "  ()" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',3005,-1,300510003,2) !!
/*  " " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',3005,-1,300510002,2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('    -',0,3006,0,0,10,0,'([300610051] is not null)  ([300610017] < 2017)',0,3,'',0,'    -',0,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('    -', 3006, 0, 0, 2) !!
/*  "  /" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('    -',3006,0,300610051,2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('   36  ',0,3006,0,0,9,0,'[300610049] like "____________________________________"  [300610049] = ""',0,3,'     36   ( ,  )',0,'     36   ( ,  )',0,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('   36  ', 3006, 0, 0, 2) !!
/*  "  " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('   36  ',3006,0,300610049,2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('  ',64,3010,-1,0,8,1,'',1,1,'         .       .',1,'',null,'',1) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('  ', 3010, -1, 0, 1) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT(' ,   ',65540,3010,-1,0,4,1,'',0,2,'     ,   .       . ,     .',0,'',null,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE(' ,   ', 3010, -1, 1, 2) !!
/*  "" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',3010,-1,301010012,2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('  ',2,3010,-1,0,8,1,'',1,1,'     ,   .       .',2,'',null,'',1) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('  ', 3010, -1, 0, 1) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('  ',65536,3010,-1,0,7,0,'',1,3,'   .   ,   .           .',2,'',null,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('  ', 3010, -1, 0, 2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT(' ',65536,3010,-1,0,6,0,'',1,1,'  .       .',2,'',null,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE(' ', 3010, -1, 0, 2) !!
/*  "  " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',3010,-1,301010019,2) !!
/*  "  ()" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',3010,-1,301010008,2) !!
/*  " " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',3010,-1,301010007,2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT(' ',65540,3010,0,0,4,1,'',0,3,'',0,'',null,'',1) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE(' ', 3010, 0, 0, 1) !!
/*  "  " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',3010,0,301010019,1) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT(' ',65540,3010,0,0,4,1,'',0,1,'  .       .',0,'',null,'',1) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE(' ', 3010, 0, 0, 1) !!
/*  "  " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',3010,0,301010019,1) !!
/*  "  ()" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',3010,0,301010008,1) !!
/*  " " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',3010,0,301010007,1) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT(' ',65540,3011,-1,0,4,1,'',0,1,'  .       .',0,'',null,'',1) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE(' ', 3011, -1, 0, 1) !!
/*  "  " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',3011,-1,301110019,1) !!
/*  "  ()" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',3011,-1,301110008,1) !!
/*  " " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',3011,-1,301110007,1) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT(' ,   ',65540,3011,-1,0,4,1,'',0,2,'     ,   .       . ,     .',0,'',null,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE(' ,   ', 3011, -1, 1, 2) !!
/*  "" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ,   ',3011,-1,301111001,2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('  ',64,3011,-1,0,8,1,'',1,1,'         .       .',1,'',null,'',1) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('  ', 3011, -1, 0, 1) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('  ',2,3011,-1,0,8,1,'',1,1,'     ,   .       .',2,'',null,'',1) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('  ', 3011, -1, 0, 1) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('  ',65536,3011,-1,0,7,0,'',1,3,'   .   ,   .           .',2,'',null,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('  ', 3011, -1, 0, 2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT(' ',65536,3011,-1,0,6,0,'',1,1,'  .       .',2,'',null,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE(' ', 3011, -1, 0, 2) !!
/*  "  " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',3011,-1,301110019,2) !!
/*  "  ()" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',3011,-1,301110008,2) !!
/*  " " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',3011,-1,301110007,2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('     ',0,3011,0,0,9,0,'[301110010] <> 6  [301110025] = 0  [301110010] = 6',0,3,' "   "       ,    "   "   "".',0,'    ""  "   "    ',0,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('     ', 3011, 0, 0, 2) !!
/*  "   " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('     ',3011,0,301110010,2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('    ',0,3011,0,0,10,0,'[301110010] = 6  [301110025] <> 0  [301110010] <> 6',0,3,' "   "       ,    "   "   "".',0,'   "   "  ""  "   "     ',0,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('    ', 3011, 0, 0, 2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('   36  ',0,3011,0,0,9,0,'[301110026] like "____________________________________"  [301110026] = ""',0,3,'     36   ( ,  )',0,'     36   ( ,  )',0,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('   36  ', 3011, 0, 0, 2) !!
/*  "  " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('   36  ',3011,0,301110026,2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('     ',0,3011,0,0,10,0,'[301110029] is not null',0,3,'',0,'     ',0,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('     ', 3011, 0, 0, 2) !!
/*  "  /" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('     ',3011,0,301110029,2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('    ',32768,3011,0,0,3,0,'[301110050] <> 0',0,3,' "     "       ',0,'',null,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('    ', 3011, 0, 0, 2) !!
/*  "     " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('    ',3011,0,301110009,2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('   ',32768,3011,0,0,3,0,'[301110010] <> 6',0,3,' "   "       ,    "   "   "".',0,'',null,'',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('   ', 3011, 0, 0, 2) !!
/*  "   " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('   ',3011,0,301110025,2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT(' ',65540,3011,0,0,4,1,'',0,1,'  .       .',0,'',null,'',1) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE(' ', 3011, 0, 0, 1) !!
/*  "  " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD(' ',3011,0,301110019,1) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('    ',0,3011,1,0,11,0,'',0,3,'     ',0,'      ',null,'([986810009])',2) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('    ', 3011, 1, 0, 2) !!
/*  "" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('    ',3011,1,301111002,2) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('     ',0,5501,1,0,11,0,'([550111066] = 2)  ((("_..",[550111052]) between 010800 and 011099))',0,3,'          ,    / , ().      0-  ,      ,   ,     0-     (  )  , , .       ,    ,       . ',0,'      ',null,'([988410006] = 0)  (.[550111090] = 0)  (.[550111156] = [988410008]) 
 ((("..",[988410006])=0)
   ((".",[988410006])=(".",.[550111090]))
   (((".",[988410006])=(".",.[550111090]))
     ((".",[988410006])=0))
   (("..",[988410006])=("..",.[550111090])))
 (((".", .[550111090]) div 100000) between 218 and 219) 
  (((".", .[550111090]) div 1000) = 11302)',1) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('     ', 5501, 1, 0, 1) !!
/*  "  " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('     ',5501,1,550111144,1) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('     ',0,5502,1,0,11,0,'([550211066] = 2)  ((("_..",[550211052]) between 010800 and 011099))',0,3,'          ,    / , ().      0-  ,      ,   ,     0-     (  )  , , .       ,    ,       . ',0,'      ',null,'([988410006] = 0)  (.[550211090] = 0)  (.[550211135] = [988410008]) 
 ((("..",[988410006])=0)
   ((".",[988410006])=(".",.[550211090]))
   (((".",[988410006])=(".",.[550211090]))
     ((".",[988410006])=0))
   (("..",[988410006])=("..",.[550211090])))
 (((".", .[550211090]) div 100000) between 218 and 219) 
  (((".", .[550211090]) div 1000) = 11302)',1) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('     ', 5502, 1, 0, 1) !!
/*  "  " */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('     ',5502,1,550211125,1) !!
EXECUTE PROCEDURE DOCLOCK_IMPORT('    ',0,9930,0,0,11,0,'',0,3,'     ',0,'      ',null,'((.[993010020] = 0)  ([986810009] = 1)) 
((.[993010020] = 1)  ([986810008] = 1)) 
((.[993010020] = 2)  ([986810007] = 1))',1) !!
EXECUTE PROCEDURE DOCLOCKFIELDS_DELETE('    ', 9930, 0, 0, 1) !!
/*  "" */
EXECUTE PROCEDURE DOCLOCKFIELDS_INSERTFIELD('    ',9930,0,993010013,1) !!
DROP PROCEDURE DOCLOCKFIELDS_INSERTFIELD !!

DROP PROCEDURE DOCLOCKFIELDS_DELETE !!

DROP PROCEDURE DOCLOCK_DELETE !!
DROP PROCEDURE DOCLOCK_IMPORT !!

CREATE PROCEDURE LINKTYPE_DELETE(NAME VARCHAR(50), TEMPLATECLS INTEGER, PARENTDOCCLS INTEGER, CHILDDOCCLS INTEGER) AS
DECLARE VARIABLE LinktypeID INTEGER;
BEGIN
  FOR SELECT ID FROM LINKTYPE LT
  WHERE ((:NAME <> '') and (LT.NAME = :NAME)) or
    ((:NAME = '') and (LT.TEMPLATECLS = :TEMPLATECLS AND LT.PARENTDOCCLS = :PARENTDOCCLS AND LT.CHILDDOCCLS = :CHILDDOCCLS))
  INTO :LinktypeID DO
  BEGIN
    UPDATE STATE_JUMPCONTROL SET
      REFERENCEREF = NULL
    WHERE REFERENCEREF = :LinktypeID;
    DELETE FROM REPLACEMENTCLSDETAIL WHERE LINKID IN (SELECT ID FROM LINKRECORDS
      WHERE LINKTYPEREF = :LinktypeID);
    DELETE FROM LINKRECORDS
      WHERE LINKTYPEREF = :LinktypeID;
    DELETE FROM LINKTYPE LT
      WHERE LT.ID = :LinktypeID;
  END
END
!!

CREATE PROCEDURE LINKTYPE_IMPORT(
   ID                    INTEGER,     
   NAME                  VARCHAR(50),
   TEMPLATECLS           INTEGER, 
   PARENTDOCCLS          INTEGER,
   CHILDDOCCLS           INTEGER,
   LINKCOMMENT           VARCHAR(255),
   BLOCKPARENT           SMALLINT,
   BLOCKCHILD            SMALLINT,
   CANDELBLOCKPARENT     SMALLINT,
   CANDELBLOCKCHILD      SMALLINT,
   PARENTPICTURETYPE     INTEGER,
   PARENTPICTURENAME     VARCHAR(255),
   CHILDPICTURETYPE      INTEGER,
   CHILDPICTURENAME      VARCHAR(255),
   PICTURECOLLECTIONNAME VARCHAR(255),
   URMUSE                SMALLINT,
   DELMACROSNAME         VARCHAR(255),
   NEEDDELCHILD          SMALLINT,
   LINKKIND              SMALLINT 
) AS
DECLARE VARIABLE OLDID INTEGER;
BEGIN
   /*         ,     */
   /* ,   , ,  ,     */
   IF (((:TEMPLATECLS is not null)and(:TEMPLATECLS<>0))or((:NAME <> '')and(:Name is not null)))   
   THEN
     FOR SELECT id FROM LINKTYPE LT WHERE
         (id<>:ID)
         and(((:TEMPLATECLS is not null)and(:TEMPLATECLS<>0)and(LT.TEMPLATECLS = :TEMPLATECLS)
     and (LT.PARENTDOCCLS = :PARENTDOCCLS) and (LT.CHILDDOCCLS = :CHILDDOCCLS))
         or((:NAME <> '')and(:Name is not null)and(lt.Name=:Name)))
     INTO :OLDID do
     BEGIN
        /*            */    
        DELETE FROM LINKRECORDS WHERE LINKTYPEREF = -10;  
        DELETE FROM LINKTYPE WHERE ID = -10;
        DELETE FROM DOCUMENTCLS WHERE ID = -10;
        DELETE FROM DOCUMENTTYPES WHERE ID = -10;
        INSERT INTO DOCUMENTTYPES(ID, PROGINDEX) VALUES(-10, -10);
        INSERT INTO DOCUMENTCLS(ID, DOCTYPE, TABLENAME, TABLENAMEURM, PRIMARYKEYNAME, PRIMARYKEYNAMEURM)
           VALUES(-10, -10, '', '', '', '');
        INSERT INTO LINKTYPE(ID, PARENTDOCCLS, CHILDDOCCLS, NAME) VALUES(-10, -10, -10, '');

        UPDATE STATE_JUMPCONTROL SET
           REFERENCEREF = -10
        WHERE
           REFERENCEREF = :OLDID;
        UPDATE LINKRECORDS SET
           LINKTYPEREF = -10
        WHERE
           LINKTYPEREF = :OLDID;

        DELETE FROM LINKTYPE WHERE ID = :OLDID;
     END
   /*     */  
   IF (NOT EXISTS (SELECT * FROM LINKTYPE LT WHERE LT.ID = :ID))
   THEN
      INSERT INTO LINKTYPE
       (ID,NAME,TEMPLATECLS,PARENTDOCCLS, CHILDDOCCLS, LINKCOMMENT, BLOCKPARENT,BLOCKCHILD,CANDELBLOCKPARENT,
        CANDELBLOCKCHILD,PARENTPICTURETYPE,PARENTPICTURENAME,CHILDPICTURETYPE,CHILDPICTURENAME,
        PICTURECOLLECTIONNAME,URMUSE,DELMACROSNAME,NEEDDELCHILD,LINKKIND)
      VALUES
       (:ID, :NAME, :TEMPLATECLS, :PARENTDOCCLS, :CHILDDOCCLS, :LINKCOMMENT, :BLOCKPARENT,:BLOCKCHILD,:CANDELBLOCKPARENT,
        :CANDELBLOCKCHILD, :PARENTPICTURETYPE,:PARENTPICTURENAME,:CHILDPICTURETYPE,:CHILDPICTURENAME,
        :PICTURECOLLECTIONNAME,:URMUSE,:DELMACROSNAME,:NEEDDELCHILD,:LINKKIND);
   ELSE
      UPDATE LINKTYPE SET
         NAME = :NAME,
         TEMPLATECLS = :TEMPLATECLS,
         PARENTDOCCLS = :PARENTDOCCLS,
         CHILDDOCCLS = :CHILDDOCCLS,
         LINKCOMMENT = :LINKCOMMENT,
         BLOCKPARENT = :BLOCKPARENT,
         BLOCKCHILD = :BLOCKCHILD,
         CANDELBLOCKPARENT = :CANDELBLOCKPARENT,
         CANDELBLOCKCHILD = :CANDELBLOCKCHILD,
         PARENTPICTURETYPE = :PARENTPICTURETYPE,
         PARENTPICTURENAME = :PARENTPICTURENAME,
         CHILDPICTURETYPE = :CHILDPICTURETYPE,
         CHILDPICTURENAME = :CHILDPICTURENAME,
         PICTURECOLLECTIONNAME = :PICTURECOLLECTIONNAME,
         URMUSE = :URMUSE,
         DELMACROSNAME = :DELMACROSNAME,
         NEEDDELCHILD = :NEEDDELCHILD,
         LINKKIND = :LINKKIND
      WHERE ID = :ID;
   /*     ,      */
   UPDATE STATE_JUMPCONTROL SET
     REFERENCEREF = :ID
   WHERE
     REFERENCEREF = -10;
   UPDATE LINKRECORDS SET
      LINKTYPEREF = :ID
   WHERE
      LINKTYPEREF = -10;
   /*  */  
   DELETE FROM LINKTYPE WHERE ID = -10;
   DELETE FROM DOCUMENTCLS WHERE ID = -10;
   DELETE FROM DOCUMENTTYPES WHERE ID = -10;
END
!!

/*   */
EXECUTE PROCEDURE LINKTYPE_IMPORT(304900700,'',null,300500,490200,'',0,0,0,0,2,'',1,'','1616',1,'',0,1) !!
EXECUTE PROCEDURE LINKTYPE_IMPORT(304900800,'',null,301000,490200,'  ',0,0,0,0,2,'',1,'','1616',1,'',0,1) !!
EXECUTE PROCEDURE LINKTYPE_IMPORT(304900900,'',null,301100,490200,'  ',0,0,0,0,2,'',1,'','1616',1,'',0,1) !!

DROP PROCEDURE LINKTYPE_DELETE !!
DROP PROCEDURE LINKTYPE_IMPORT !!

CREATE PROCEDURE STATICLINK_DELETE(ID INTEGER) AS
BEGIN
  DELETE FROM STATICLINKS SL
  WHERE SL.ID = :ID;
END
!!

CREATE PROCEDURE STATICLINK_IMPORT(
  ID             INTEGER,
  NAME           VARCHAR(255),
  PARENTFIELDREF INTEGER,
  CHILDFIELDREF  INTEGER,
  LINKKIND      INTEGER,
  ParentDelAction INTEGER
) AS
DECLARE VARIABLE FINDID INTEGER;
BEGIN
  /*    ID,    CHILDFIELDREF,PARENTFIELDREF. 
   ,     ,    ID.       ID  , 
   (  )     id ,      */
  FINDID = NULL;
  SELECT
    SL.ID
  FROM 
    STATICLINKS SL
  WHERE (SL.CHILDFIELDREF = :CHILDFIELDREF) AND (SL.PARENTFIELDREF = :PARENTFIELDREF) AND (SL.ID <> :ID)
  INTO :FINDID;
  
  IF (:FINDID IS NOT NULL) THEN
  BEGIN
    /*  ID         */
    IF  (EXISTS (
        SELECT ID FROM STATE_JUMPCONTROL
        WHERE (STATICLINKREF = :FINDID ))) 
    THEN   
    BEGIN
      IF (NOT EXISTS (
        SELECT ID FROM STATICLINKS SL
      WHERE SL.ID = :ID )) THEN
      INSERT INTO STATICLINKS
        (ID,NAME,PARENTFIELDREF,CHILDFIELDREF,LINKKIND,ParentDelAction)
      VALUES
        (:ID,:NAME,:CHILDFIELDREF,:PARENTFIELDREF,1,:ParentDelAction); /*  ,       */
        
      UPDATE STATE_JUMPCONTROL
        SET STATICLINKREF = :ID
      WHERE (STATICLINKREF = :FINDID);

      DELETE FROM STATICLINKS  
      WHERE ID=:FINDID;
        
    END
    ELSE   
      IF (NOT EXISTS (
        SELECT ID FROM STATICLINKS SL
        WHERE SL.ID = :ID )) THEN
      begin
        UPDATE STATICLINKS
        SET ID=:ID
        WHERE ID=:FINDID;
      end
      else
        DELETE FROM STATICLINKS
        WHERE ID=:FINDID;
    
  END /* id  */

  /*      ( ), 
   ,            CHILDFIELDREF.
   ,        1( )*/
  IF (:LINKKIND=0) THEN
    UPDATE STATICLINKS
    SET LINKKIND=1  
    WHERE (CHILDFIELDREF = :CHILDFIELDREF) AND (ID <> :ID) AND (LINKKIND=0);
  
  /*       id.  ,   .  ,   */
  
  IF (EXISTS (
    SELECT ID FROM STATICLINKS SL
    WHERE SL.ID = :ID )) THEN
  BEGIN
    UPDATE STATICLINKS SET
      NAME           = :NAME,
      PARENTFIELDREF = :PARENTFIELDREF,
      CHILDFIELDREF  = :CHILDFIELDREF,
      LINKKIND       = :LINKKIND,
      ParentDelAction = :ParentDelAction
    WHERE ID = :ID;
  END ELSE
  BEGIN
    INSERT INTO STATICLINKS
      (ID,NAME,PARENTFIELDREF,CHILDFIELDREF,LINKKIND,ParentDelAction)
    VALUES
      (:ID,:NAME,:PARENTFIELDREF,:CHILDFIELDREF,:LINKKIND,:ParentDelAction);
  END
END
!!

/*   */
EXECUTE PROCEDURE STATICLINK_DELETE(999903600) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(982506500,'.DOCTYPE->.ID',981110005,250410094,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(999903700,'.KESR()->.ID',986810006,993010013,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(990908000,'_.KESR()->.ID',986810006,90610082,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(990908200,'_.1.KESR()->.ID',986810006,90611088,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(992502400,'.AUTOSANCTION()->.ID',993010001,250410100,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(993001300,'.BUDGETREF->.ID',987810006,301010001,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(993001400,'.REJECTCLS()->.ID',985010005,301010007,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(983002600,'.FACIALACCCLS->.ID',984110021,301010014,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(993001800,'.BUDGETREF->.ID',987810006,301110001,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(993002000,'.1.KESR->.ID',986810006,301111002,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(983003500,'.1.KCSR->.ID',980510002,301111003,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(983003700,'.1.FACIALACCCLS->.ID',984110021,301111006,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(993001900,'.REJECTCLS()->.ID',985010005,301110007,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(983003600,'.FACIALACCCLS->.ID',984110021,301110014,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(983003800,'.1.KVSR->.ID',980310002,301111025,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(983003900,'.1.KFSR->.ID',980210004,301111026,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(983004000,'.1.KVR->.ID',980410002,301111027,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(983004100,'.1.MEANSTYPECLS->.ID',984910002,301111028,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(983004200,'.1.SUBKESR->.ID',980810002,301111038,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(993002100,'.1.FINSOURCECLS->.ID',985210008,301111040,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(983004300,'.1.FINTYPE->.ID',982710006,301111041,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(993002200,'.1.DIRECTIONCLS->.ID',986910002,301111042,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(983004400,'.1.FACTCLS->.ID',982810005,301111045,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(993002300,'-.BUDGETREF->.ID',987810006,300510001,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(993002400,'-.REJECTCLS()->.ID',985010005,300510002,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(983004500,'-.FACIALACCCLS->.ID',984110021,300510007,0,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(303000000,'.ParentRef->.ID',301110029,301010031,1,0) !!
EXECUTE PROCEDURE STATICLINK_IMPORT(303000100,' -.ParentRef->-.ID',300610051,300510018,1,0) !!

DROP PROCEDURE STATICLINK_DELETE !!
DROP PROCEDURE STATICLINK_IMPORT !!

CREATE PROCEDURE FILTERS_DELETE(ID INTEGER) AS
BEGIN
  DELETE FROM STATE_JUMPCONTROL
  WHERE STATE_JUMPCONTROL.FILTERCODE = :ID;
  UPDATE STATE_ACTIONJUMPS SAJ
  SET SAJ.FILTERCODE = NULL, SAJ.OPTIONS = NULL
  WHERE SAJ.FILTERCODE = :ID;
  DELETE FROM State_Filter SF
  WHERE SF.ID = :ID;
END
!!

CREATE PROCEDURE FILTERS_IMPORT(
  ID integer,
  Name Varchar(255),
  Note Varchar(255),
  FilterValue Varchar(1024),
  FilterFormat integer,
  FilterActive integer,
  IsBudget integer
) AS
BEGIN
  IF (EXISTS (
    SELECT ID FROM State_Filter
    WHERE State_Filter.ID = :ID ))
  THEN
  BEGIN
    UPDATE State_Filter SET
      NAME = :NAME,
      Note = :Note,
      FilterValue = :FilterValue,
      FilterFormat = :FilterFormat,
      FilterActive = :FilterActive,
      IsBudget = :IsBudget
    WHERE ID = :ID;
  END
  ELSE
  BEGIN
    INSERT INTO State_Filter
      (ID,NAME,Note,FilterValue,FilterFormat,IsBudget,FilterActive)
    VALUES
      (:ID,:NAME,:Note,:FilterValue,:FilterFormat,:IsBudget,:FilterActive);
  END
END
!!

CREATE PROCEDURE FILTERS_IMPORTURM(
  ID integer,
  Name Varchar(255),
  Note Varchar(255),
  FilterValueURM Varchar(1024),
  FilterFormat integer,
  FilterActive integer,
  IsBudget integer
) AS
BEGIN
  IF (EXISTS (
    SELECT ID FROM State_Filter
    WHERE State_Filter.ID = :ID ))
  THEN
  BEGIN
    UPDATE State_Filter SET
      NAME = :NAME,
      Note = :Note,
      FilterValueURM = :FilterValueURM,
      FilterFormat = :FilterFormat,
      FilterActive = :FilterActive,
      IsBudget = :IsBudget
    WHERE ID = :ID;
  END
  ELSE
  BEGIN
    INSERT INTO State_Filter
      (ID,NAME,Note,FilterValueURM,FilterFormat,IsBudget,FilterActive)
    VALUES
      (:ID,:NAME,:Note,:FilterValueURM,:FilterFormat,:IsBudget,:FilterActive);
  END
END
!!

/*  */

DROP PROCEDURE FILTERS_DELETE !!
DROP PROCEDURE FILTERS_IMPORT !!
DROP PROCEDURE FILTERS_IMPORTURM !!

CREATE PROCEDURE STATUSICONS_IMPORT(
  ID INTEGER,
  NOTE VARCHAR(255),
  DOCREF INTEGER,
  DETAILNUM INTEGER,
  ICONNAME VARCHAR(255),
  ISSYSTEM INTEGER,
  ICONPOS INTEGER,
  RUNPOS INTEGER,
  RESERVEPOS INTEGER,
  ICONHINT VARCHAR(255),
  ICONKIND INTEGER,
  LOCKMASK INTEGER,
  FORMULA VARCHAR(1024),
  ISBUDGET INTEGER
) AS
BEGIN
  IF (EXISTS (
    SELECT ID FROM STATUSICONS SI
    WHERE SI.ID = :ID ))
  THEN
  BEGIN
    UPDATE STATUSICONS SET
      NOTE = :NOTE,
      DOCREF = :DOCREF,
      DETAILNUM = :DETAILNUM,
      ICONNAME = :ICONNAME,
      ISSYSTEM = :ISSYSTEM,
      ICONPOS = :ICONPOS,
      RUNPOS = :RUNPOS,
      RESERVEPOS = :RESERVEPOS,
      ICONHINT = :ICONHINT,
      ICONKIND = :ICONKIND,
      LOCKMASK = :LOCKMASK,
      FORMULA = :FORMULA,
      ISBUDGET = :ISBUDGET
    WHERE ID = :ID;
  END ELSE
  BEGIN
    INSERT INTO STATUSICONS
      (ID, NOTE, DOCREF, DETAILNUM, ICONNAME, ISSYSTEM, ICONPOS, RUNPOS, RESERVEPOS, ICONHINT, ICONKIND, LOCKMASK, FORMULA, ISBUDGET)
    VALUES
      (:ID, :NOTE, :DOCREF, :DETAILNUM, :ICONNAME, :ISSYSTEM, :ICONPOS, :RUNPOS, :RESERVEPOS, :ICONHINT, :ICONKIND, :LOCKMASK, :FORMULA, :ISBUDGET);
  END
END
!!

CREATE PROCEDURE STATUSICONS_DELETE(
  ID INTEGER
) AS
BEGIN
  DELETE FROM STATUSICONS SI
  WHERE SI.ID = :ID;
END
!!

/*   */

DROP PROCEDURE STATUSICONS_IMPORT !!
DROP PROCEDURE STATUSICONS_DELETE !!


CREATE PROCEDURE ENUMS_IMPORT(NAME VARCHAR(255),FACIALACCCLS INTEGER) AS
  DECLARE VARIABLE IDEXISTS INTEGER;
BEGIN
  SELECT COUNT(ID) FROM ENUMS WHERE NAME = :NAME INTO :IDEXISTS;
  IF (:IDEXISTS > 1) THEN
      DELETE FROM ENUMS E1
      WHERE (E1.NAME = :NAME) AND (E1.ID > (SELECT MIN(E2.ID) FROM ENUMS E2 WHERE E2.NAME = :NAME));
  IF (:IDEXISTS > 0) THEN
    UPDATE ENUMS SET
      FACIALACCCLS = :FACIALACCCLS,
      ISSYSTEM = 1
    WHERE NAME = :NAME;
  ELSE
    INSERT INTO ENUMS
      (NAME,FACIALACCCLS,ISSYSTEM)    
    VALUES
      (:NAME,:FACIALACCCLS,1);
END
!!

CREATE PROCEDURE ENUMVALUES_IMPORT(ENUMNAME VARCHAR(255),NAME VARCHAR(1024),VAL INTEGER) AS
  DECLARE VARIABLE IDENUM INTEGER;
  DECLARE VARIABLE IDEXISTS INTEGER;
BEGIN
  SELECT ID FROM ENUMS WHERE NAME = :ENUMNAME INTO :IDENUM;
  IF (:IDENUM IS NOT NULL) THEN
  BEGIN
    SELECT COUNT(ID) FROM ENUMVALUES WHERE ENUMREF = :IDENUM AND VAL = :VAL INTO :IDEXISTS;
    IF (:IDEXISTS > 1) THEN
      DELETE FROM ENUMVALUES EV1
      WHERE (EV1.ENUMREF = :IDENUM) AND (EV1.VAL = :VAL) AND
        (EV1.ID > (SELECT MIN(EV2.ID) FROM ENUMVALUES EV2 WHERE EV2.ENUMREF = :IDENUM AND EV2.VAL = :VAL));
    IF (:IDEXISTS > 0) THEN
      UPDATE ENUMVALUES SET
        NAME = :NAME
      WHERE ENUMREF = :IDENUM AND VAL = :VAL;
    ELSE
      INSERT INTO ENUMVALUES
        (VAL,NAME,ENUMREF)  
      VALUES
        (:VAL,:NAME,:IDENUM);
  END  
END
!!

CREATE PROCEDURE ENUMS_DELETE(NAME VARCHAR(255)) AS
BEGIN
  DELETE FROM ENUMS WHERE NAME = :NAME;
END
!!

CREATE PROCEDURE ENUMVALUES_DELETE(ENUMNAME VARCHAR(255),VAL INTEGER) AS
  DECLARE VARIABLE IDENUM INTEGER;
BEGIN
  SELECT ID FROM ENUMS WHERE NAME = :ENUMNAME INTO :IDENUM;
  IF (:IDENUM IS NOT NULL) THEN
    DELETE FROM ENUMVALUES WHERE VAL = :VAL AND ENUMREF = :IDENUM;
END
!!

/*  */
EXECUTE PROCEDURE ENUMS_IMPORT('',null) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','',0) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','   ',1) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','',2) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','',3) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','  ',4) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','   ',5) !!
EXECUTE PROCEDURE ENUMVALUES_IMPORT('','',6) !!

DROP PROCEDURE ENUMS_IMPORT !!
DROP PROCEDURE ENUMVALUES_IMPORT !!
DROP PROCEDURE ENUMS_DELETE !!
DROP PROCEDURE ENUMVALUES_DELETE !!



/*       */
INSERT INTO DFUCHANGELOG (VersionID, BEGINUPDATECODE, ENDUPDATECODE, LASTUPDATEDFU, ISBUDGET, INCLUDEDEL, INCLUDEBLOCKS, INCLUDEDOCS, SCRIPTCREATOR, SCRIPTCREATEDATE, NOTE) VALUES (1426, 113000, 113000, '25.08.2016 13:18:14', 1, 1, ',    ,  , ,  , ,  , , ', '02.00, 03.23, 03.24, 09.06, 25.04, 30.01, 30.05, 30.06, 30.10, 30.11, 55.01, 55.02, 55.03, 99.16, 99.30', 'MALINOVKIN/malinovkin', '25.08.2016 17:27:32', '') !!


COMMIT WORK!!



INSERT INTO DataBaseVersion(VERSION, Major, Minor, AComment) 
VALUES ('11.30.00', 1130, 00, ' 11.30.00')!!


commit work !!

set term ; !!
