SPOOL AuditDropOldTgrAndViews.lst

/*      */

declare
  cursor c$ is
  select 'drop trigger ' || TRIGGER_NAME as str
  from dba_triggers
  where owner = SYS_CONTEXT ('USERENV', 'CURRENT_SCHEMA')
    and substr(TRIGGER_NAME,1,4) in ('ATU_','ATI_','ATD_')
  union
  select 'drop view ' || view_NAME as str
  from dba_views
  where owner = SYS_CONTEXT ('USERENV', 'CURRENT_SCHEMA')
    and (substr(view_NAME,1,3) in ('AG_','AT_')
     or substr(view_NAME,1,2) = 'A_');
begin
  for r$ in c$ loop
    execute immediate r$.str;
  end loop;
end;
/

SPOOL OFF

exit
